/*
 * Copyright 2020 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: google/cloud/audit/audit_log.proto

package org.apache.ratis.thirdparty.com.google.cloud.audit;

/**
 *
 *
 * <pre>
 * Authorization information for the operation.
 * </pre>
 *
 * Protobuf type {@code google.cloud.audit.AuthorizationInfo}
 */
public final class AuthorizationInfo extends org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3
    implements
    // @@protoc_insertion_point(message_implements:google.cloud.audit.AuthorizationInfo)
    AuthorizationInfoOrBuilder {
  private static final long serialVersionUID = 0L;
  // Use AuthorizationInfo.newBuilder() to construct.
  private AuthorizationInfo(org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }

  private AuthorizationInfo() {
    resource_ = "";
    permission_ = "";
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(UnusedPrivateParameter unused) {
    return new AuthorizationInfo();
  }

  @java.lang.Override
  public final org.apache.ratis.thirdparty.com.google.protobuf.UnknownFieldSet getUnknownFields() {
    return this.unknownFields;
  }

  private AuthorizationInfo(
      org.apache.ratis.thirdparty.com.google.protobuf.CodedInputStream input,
      org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
    this();
    if (extensionRegistry == null) {
      throw new java.lang.NullPointerException();
    }
    org.apache.ratis.thirdparty.com.google.protobuf.UnknownFieldSet.Builder unknownFields =
        org.apache.ratis.thirdparty.com.google.protobuf.UnknownFieldSet.newBuilder();
    try {
      boolean done = false;
      while (!done) {
        int tag = input.readTag();
        switch (tag) {
          case 0:
            done = true;
            break;
          case 10:
            {
              java.lang.String s = input.readStringRequireUtf8();

              resource_ = s;
              break;
            }
          case 18:
            {
              java.lang.String s = input.readStringRequireUtf8();

              permission_ = s;
              break;
            }
          case 24:
            {
              granted_ = input.readBool();
              break;
            }
          case 42:
            {
              org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.Resource.Builder subBuilder = null;
              if (resourceAttributes_ != null) {
                subBuilder = resourceAttributes_.toBuilder();
              }
              resourceAttributes_ =
                  input.readMessage(
                      org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.Resource.parser(), extensionRegistry);
              if (subBuilder != null) {
                subBuilder.mergeFrom(resourceAttributes_);
                resourceAttributes_ = subBuilder.buildPartial();
              }

              break;
            }
          default:
            {
              if (!parseUnknownField(input, unknownFields, extensionRegistry, tag)) {
                done = true;
              }
              break;
            }
        }
      }
    } catch (org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException e) {
      throw e.setUnfinishedMessage(this);
    } catch (java.io.IOException e) {
      throw new org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException(e).setUnfinishedMessage(this);
    } finally {
      this.unknownFields = unknownFields.build();
      makeExtensionsImmutable();
    }
  }

  public static final org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.Descriptor getDescriptor() {
    return org.apache.ratis.thirdparty.com.google.cloud.audit.AuditLogProto
        .internal_static_google_cloud_audit_AuthorizationInfo_descriptor;
  }

  @java.lang.Override
  protected org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return org.apache.ratis.thirdparty.com.google.cloud.audit.AuditLogProto
        .internal_static_google_cloud_audit_AuthorizationInfo_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            org.apache.ratis.thirdparty.com.google.cloud.audit.AuthorizationInfo.class,
            org.apache.ratis.thirdparty.com.google.cloud.audit.AuthorizationInfo.Builder.class);
  }

  public static final int RESOURCE_FIELD_NUMBER = 1;
  private volatile java.lang.Object resource_;
  /**
   *
   *
   * <pre>
   * The resource being accessed, as a REST-style string. For example:
   *     bigquery.googleapis.com/projects/PROJECTID/datasets/DATASETID
   * </pre>
   *
   * <code>string resource = 1;</code>
   *
   * @return The resource.
   */
  @java.lang.Override
  public java.lang.String getResource() {
    java.lang.Object ref = resource_;
    if (ref instanceof java.lang.String) {
      return (java.lang.String) ref;
    } else {
      org.apache.ratis.thirdparty.com.google.protobuf.ByteString bs = (org.apache.ratis.thirdparty.com.google.protobuf.ByteString) ref;
      java.lang.String s = bs.toStringUtf8();
      resource_ = s;
      return s;
    }
  }
  /**
   *
   *
   * <pre>
   * The resource being accessed, as a REST-style string. For example:
   *     bigquery.googleapis.com/projects/PROJECTID/datasets/DATASETID
   * </pre>
   *
   * <code>string resource = 1;</code>
   *
   * @return The bytes for resource.
   */
  @java.lang.Override
  public org.apache.ratis.thirdparty.com.google.protobuf.ByteString getResourceBytes() {
    java.lang.Object ref = resource_;
    if (ref instanceof java.lang.String) {
      org.apache.ratis.thirdparty.com.google.protobuf.ByteString b =
          org.apache.ratis.thirdparty.com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
      resource_ = b;
      return b;
    } else {
      return (org.apache.ratis.thirdparty.com.google.protobuf.ByteString) ref;
    }
  }

  public static final int PERMISSION_FIELD_NUMBER = 2;
  private volatile java.lang.Object permission_;
  /**
   *
   *
   * <pre>
   * The required IAM permission.
   * </pre>
   *
   * <code>string permission = 2;</code>
   *
   * @return The permission.
   */
  @java.lang.Override
  public java.lang.String getPermission() {
    java.lang.Object ref = permission_;
    if (ref instanceof java.lang.String) {
      return (java.lang.String) ref;
    } else {
      org.apache.ratis.thirdparty.com.google.protobuf.ByteString bs = (org.apache.ratis.thirdparty.com.google.protobuf.ByteString) ref;
      java.lang.String s = bs.toStringUtf8();
      permission_ = s;
      return s;
    }
  }
  /**
   *
   *
   * <pre>
   * The required IAM permission.
   * </pre>
   *
   * <code>string permission = 2;</code>
   *
   * @return The bytes for permission.
   */
  @java.lang.Override
  public org.apache.ratis.thirdparty.com.google.protobuf.ByteString getPermissionBytes() {
    java.lang.Object ref = permission_;
    if (ref instanceof java.lang.String) {
      org.apache.ratis.thirdparty.com.google.protobuf.ByteString b =
          org.apache.ratis.thirdparty.com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
      permission_ = b;
      return b;
    } else {
      return (org.apache.ratis.thirdparty.com.google.protobuf.ByteString) ref;
    }
  }

  public static final int GRANTED_FIELD_NUMBER = 3;
  private boolean granted_;
  /**
   *
   *
   * <pre>
   * Whether or not authorization for `resource` and `permission`
   * was granted.
   * </pre>
   *
   * <code>bool granted = 3;</code>
   *
   * @return The granted.
   */
  @java.lang.Override
  public boolean getGranted() {
    return granted_;
  }

  public static final int RESOURCE_ATTRIBUTES_FIELD_NUMBER = 5;
  private org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.Resource resourceAttributes_;
  /**
   *
   *
   * <pre>
   * Resource attributes used in IAM condition evaluation. This field contains
   * resource attributes like resource type and resource name.
   * To get the whole view of the attributes used in IAM
   * condition evaluation, the user must also look into
   * `AuditLog.request_metadata.request_attributes`.
   * </pre>
   *
   * <code>.google.rpc.context.AttributeContext.Resource resource_attributes = 5;</code>
   *
   * @return Whether the resourceAttributes field is set.
   */
  @java.lang.Override
  public boolean hasResourceAttributes() {
    return resourceAttributes_ != null;
  }
  /**
   *
   *
   * <pre>
   * Resource attributes used in IAM condition evaluation. This field contains
   * resource attributes like resource type and resource name.
   * To get the whole view of the attributes used in IAM
   * condition evaluation, the user must also look into
   * `AuditLog.request_metadata.request_attributes`.
   * </pre>
   *
   * <code>.google.rpc.context.AttributeContext.Resource resource_attributes = 5;</code>
   *
   * @return The resourceAttributes.
   */
  @java.lang.Override
  public org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.Resource getResourceAttributes() {
    return resourceAttributes_ == null
        ? org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.Resource.getDefaultInstance()
        : resourceAttributes_;
  }
  /**
   *
   *
   * <pre>
   * Resource attributes used in IAM condition evaluation. This field contains
   * resource attributes like resource type and resource name.
   * To get the whole view of the attributes used in IAM
   * condition evaluation, the user must also look into
   * `AuditLog.request_metadata.request_attributes`.
   * </pre>
   *
   * <code>.google.rpc.context.AttributeContext.Resource resource_attributes = 5;</code>
   */
  @java.lang.Override
  public org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.ResourceOrBuilder
      getResourceAttributesOrBuilder() {
    return getResourceAttributes();
  }

  private byte memoizedIsInitialized = -1;

  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(org.apache.ratis.thirdparty.com.google.protobuf.CodedOutputStream output) throws java.io.IOException {
    if (!getResourceBytes().isEmpty()) {
      org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.writeString(output, 1, resource_);
    }
    if (!getPermissionBytes().isEmpty()) {
      org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.writeString(output, 2, permission_);
    }
    if (granted_ != false) {
      output.writeBool(3, granted_);
    }
    if (resourceAttributes_ != null) {
      output.writeMessage(5, getResourceAttributes());
    }
    unknownFields.writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (!getResourceBytes().isEmpty()) {
      size += org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.computeStringSize(1, resource_);
    }
    if (!getPermissionBytes().isEmpty()) {
      size += org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.computeStringSize(2, permission_);
    }
    if (granted_ != false) {
      size += org.apache.ratis.thirdparty.com.google.protobuf.CodedOutputStream.computeBoolSize(3, granted_);
    }
    if (resourceAttributes_ != null) {
      size += org.apache.ratis.thirdparty.com.google.protobuf.CodedOutputStream.computeMessageSize(5, getResourceAttributes());
    }
    size += unknownFields.getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
      return true;
    }
    if (!(obj instanceof org.apache.ratis.thirdparty.com.google.cloud.audit.AuthorizationInfo)) {
      return super.equals(obj);
    }
    org.apache.ratis.thirdparty.com.google.cloud.audit.AuthorizationInfo other = (org.apache.ratis.thirdparty.com.google.cloud.audit.AuthorizationInfo) obj;

    if (!getResource().equals(other.getResource())) return false;
    if (!getPermission().equals(other.getPermission())) return false;
    if (getGranted() != other.getGranted()) return false;
    if (hasResourceAttributes() != other.hasResourceAttributes()) return false;
    if (hasResourceAttributes()) {
      if (!getResourceAttributes().equals(other.getResourceAttributes())) return false;
    }
    if (!unknownFields.equals(other.unknownFields)) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    hash = (37 * hash) + RESOURCE_FIELD_NUMBER;
    hash = (53 * hash) + getResource().hashCode();
    hash = (37 * hash) + PERMISSION_FIELD_NUMBER;
    hash = (53 * hash) + getPermission().hashCode();
    hash = (37 * hash) + GRANTED_FIELD_NUMBER;
    hash = (53 * hash) + org.apache.ratis.thirdparty.com.google.protobuf.Internal.hashBoolean(getGranted());
    if (hasResourceAttributes()) {
      hash = (37 * hash) + RESOURCE_ATTRIBUTES_FIELD_NUMBER;
      hash = (53 * hash) + getResourceAttributes().hashCode();
    }
    hash = (29 * hash) + unknownFields.hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static org.apache.ratis.thirdparty.com.google.cloud.audit.AuthorizationInfo parseFrom(java.nio.ByteBuffer data)
      throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }

  public static org.apache.ratis.thirdparty.com.google.cloud.audit.AuthorizationInfo parseFrom(
      java.nio.ByteBuffer data, org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }

  public static org.apache.ratis.thirdparty.com.google.cloud.audit.AuthorizationInfo parseFrom(
      org.apache.ratis.thirdparty.com.google.protobuf.ByteString data)
      throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }

  public static org.apache.ratis.thirdparty.com.google.cloud.audit.AuthorizationInfo parseFrom(
      org.apache.ratis.thirdparty.com.google.protobuf.ByteString data,
      org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }

  public static org.apache.ratis.thirdparty.com.google.cloud.audit.AuthorizationInfo parseFrom(byte[] data)
      throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }

  public static org.apache.ratis.thirdparty.com.google.cloud.audit.AuthorizationInfo parseFrom(
      byte[] data, org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }

  public static org.apache.ratis.thirdparty.com.google.cloud.audit.AuthorizationInfo parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseWithIOException(PARSER, input);
  }

  public static org.apache.ratis.thirdparty.com.google.cloud.audit.AuthorizationInfo parseFrom(
      java.io.InputStream input, org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseWithIOException(
        PARSER, input, extensionRegistry);
  }

  public static org.apache.ratis.thirdparty.com.google.cloud.audit.AuthorizationInfo parseDelimitedFrom(
      java.io.InputStream input) throws java.io.IOException {
    return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseDelimitedWithIOException(PARSER, input);
  }

  public static org.apache.ratis.thirdparty.com.google.cloud.audit.AuthorizationInfo parseDelimitedFrom(
      java.io.InputStream input, org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseDelimitedWithIOException(
        PARSER, input, extensionRegistry);
  }

  public static org.apache.ratis.thirdparty.com.google.cloud.audit.AuthorizationInfo parseFrom(
      org.apache.ratis.thirdparty.com.google.protobuf.CodedInputStream input) throws java.io.IOException {
    return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseWithIOException(PARSER, input);
  }

  public static org.apache.ratis.thirdparty.com.google.cloud.audit.AuthorizationInfo parseFrom(
      org.apache.ratis.thirdparty.com.google.protobuf.CodedInputStream input,
      org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseWithIOException(
        PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() {
    return newBuilder();
  }

  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }

  public static Builder newBuilder(org.apache.ratis.thirdparty.com.google.cloud.audit.AuthorizationInfo prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }

  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   *
   *
   * <pre>
   * Authorization information for the operation.
   * </pre>
   *
   * Protobuf type {@code google.cloud.audit.AuthorizationInfo}
   */
  public static final class Builder extends org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.Builder<Builder>
      implements
      // @@protoc_insertion_point(builder_implements:google.cloud.audit.AuthorizationInfo)
      org.apache.ratis.thirdparty.com.google.cloud.audit.AuthorizationInfoOrBuilder {
    public static final org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.Descriptor getDescriptor() {
      return org.apache.ratis.thirdparty.com.google.cloud.audit.AuditLogProto
          .internal_static_google_cloud_audit_AuthorizationInfo_descriptor;
    }

    @java.lang.Override
    protected org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return org.apache.ratis.thirdparty.com.google.cloud.audit.AuditLogProto
          .internal_static_google_cloud_audit_AuthorizationInfo_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              org.apache.ratis.thirdparty.com.google.cloud.audit.AuthorizationInfo.class,
              org.apache.ratis.thirdparty.com.google.cloud.audit.AuthorizationInfo.Builder.class);
    }

    // Construct using org.apache.ratis.thirdparty.com.google.cloud.audit.AuthorizationInfo.newBuilder()
    private Builder() {
      maybeForceBuilderInitialization();
    }

    private Builder(org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);
      maybeForceBuilderInitialization();
    }

    private void maybeForceBuilderInitialization() {
      if (org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.alwaysUseFieldBuilders) {}
    }

    @java.lang.Override
    public Builder clear() {
      super.clear();
      resource_ = "";

      permission_ = "";

      granted_ = false;

      if (resourceAttributesBuilder_ == null) {
        resourceAttributes_ = null;
      } else {
        resourceAttributes_ = null;
        resourceAttributesBuilder_ = null;
      }
      return this;
    }

    @java.lang.Override
    public org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.Descriptor getDescriptorForType() {
      return org.apache.ratis.thirdparty.com.google.cloud.audit.AuditLogProto
          .internal_static_google_cloud_audit_AuthorizationInfo_descriptor;
    }

    @java.lang.Override
    public org.apache.ratis.thirdparty.com.google.cloud.audit.AuthorizationInfo getDefaultInstanceForType() {
      return org.apache.ratis.thirdparty.com.google.cloud.audit.AuthorizationInfo.getDefaultInstance();
    }

    @java.lang.Override
    public org.apache.ratis.thirdparty.com.google.cloud.audit.AuthorizationInfo build() {
      org.apache.ratis.thirdparty.com.google.cloud.audit.AuthorizationInfo result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public org.apache.ratis.thirdparty.com.google.cloud.audit.AuthorizationInfo buildPartial() {
      org.apache.ratis.thirdparty.com.google.cloud.audit.AuthorizationInfo result =
          new org.apache.ratis.thirdparty.com.google.cloud.audit.AuthorizationInfo(this);
      result.resource_ = resource_;
      result.permission_ = permission_;
      result.granted_ = granted_;
      if (resourceAttributesBuilder_ == null) {
        result.resourceAttributes_ = resourceAttributes_;
      } else {
        result.resourceAttributes_ = resourceAttributesBuilder_.build();
      }
      onBuilt();
      return result;
    }

    @java.lang.Override
    public Builder clone() {
      return super.clone();
    }

    @java.lang.Override
    public Builder setField(
        org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.FieldDescriptor field, java.lang.Object value) {
      return super.setField(field, value);
    }

    @java.lang.Override
    public Builder clearField(org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.FieldDescriptor field) {
      return super.clearField(field);
    }

    @java.lang.Override
    public Builder clearOneof(org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.OneofDescriptor oneof) {
      return super.clearOneof(oneof);
    }

    @java.lang.Override
    public Builder setRepeatedField(
        org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.FieldDescriptor field, int index, java.lang.Object value) {
      return super.setRepeatedField(field, index, value);
    }

    @java.lang.Override
    public Builder addRepeatedField(
        org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.FieldDescriptor field, java.lang.Object value) {
      return super.addRepeatedField(field, value);
    }

    @java.lang.Override
    public Builder mergeFrom(org.apache.ratis.thirdparty.com.google.protobuf.Message other) {
      if (other instanceof org.apache.ratis.thirdparty.com.google.cloud.audit.AuthorizationInfo) {
        return mergeFrom((org.apache.ratis.thirdparty.com.google.cloud.audit.AuthorizationInfo) other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(org.apache.ratis.thirdparty.com.google.cloud.audit.AuthorizationInfo other) {
      if (other == org.apache.ratis.thirdparty.com.google.cloud.audit.AuthorizationInfo.getDefaultInstance()) return this;
      if (!other.getResource().isEmpty()) {
        resource_ = other.resource_;
        onChanged();
      }
      if (!other.getPermission().isEmpty()) {
        permission_ = other.permission_;
        onChanged();
      }
      if (other.getGranted() != false) {
        setGranted(other.getGranted());
      }
      if (other.hasResourceAttributes()) {
        mergeResourceAttributes(other.getResourceAttributes());
      }
      this.mergeUnknownFields(other.unknownFields);
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        org.apache.ratis.thirdparty.com.google.protobuf.CodedInputStream input,
        org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      org.apache.ratis.thirdparty.com.google.cloud.audit.AuthorizationInfo parsedMessage = null;
      try {
        parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
      } catch (org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException e) {
        parsedMessage = (org.apache.ratis.thirdparty.com.google.cloud.audit.AuthorizationInfo) e.getUnfinishedMessage();
        throw e.unwrapIOException();
      } finally {
        if (parsedMessage != null) {
          mergeFrom(parsedMessage);
        }
      }
      return this;
    }

    private java.lang.Object resource_ = "";
    /**
     *
     *
     * <pre>
     * The resource being accessed, as a REST-style string. For example:
     *     bigquery.googleapis.com/projects/PROJECTID/datasets/DATASETID
     * </pre>
     *
     * <code>string resource = 1;</code>
     *
     * @return The resource.
     */
    public java.lang.String getResource() {
      java.lang.Object ref = resource_;
      if (!(ref instanceof java.lang.String)) {
        org.apache.ratis.thirdparty.com.google.protobuf.ByteString bs = (org.apache.ratis.thirdparty.com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        resource_ = s;
        return s;
      } else {
        return (java.lang.String) ref;
      }
    }
    /**
     *
     *
     * <pre>
     * The resource being accessed, as a REST-style string. For example:
     *     bigquery.googleapis.com/projects/PROJECTID/datasets/DATASETID
     * </pre>
     *
     * <code>string resource = 1;</code>
     *
     * @return The bytes for resource.
     */
    public org.apache.ratis.thirdparty.com.google.protobuf.ByteString getResourceBytes() {
      java.lang.Object ref = resource_;
      if (ref instanceof String) {
        org.apache.ratis.thirdparty.com.google.protobuf.ByteString b =
            org.apache.ratis.thirdparty.com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
        resource_ = b;
        return b;
      } else {
        return (org.apache.ratis.thirdparty.com.google.protobuf.ByteString) ref;
      }
    }
    /**
     *
     *
     * <pre>
     * The resource being accessed, as a REST-style string. For example:
     *     bigquery.googleapis.com/projects/PROJECTID/datasets/DATASETID
     * </pre>
     *
     * <code>string resource = 1;</code>
     *
     * @param value The resource to set.
     * @return This builder for chaining.
     */
    public Builder setResource(java.lang.String value) {
      if (value == null) {
        throw new NullPointerException();
      }

      resource_ = value;
      onChanged();
      return this;
    }
    /**
     *
     *
     * <pre>
     * The resource being accessed, as a REST-style string. For example:
     *     bigquery.googleapis.com/projects/PROJECTID/datasets/DATASETID
     * </pre>
     *
     * <code>string resource = 1;</code>
     *
     * @return This builder for chaining.
     */
    public Builder clearResource() {

      resource_ = getDefaultInstance().getResource();
      onChanged();
      return this;
    }
    /**
     *
     *
     * <pre>
     * The resource being accessed, as a REST-style string. For example:
     *     bigquery.googleapis.com/projects/PROJECTID/datasets/DATASETID
     * </pre>
     *
     * <code>string resource = 1;</code>
     *
     * @param value The bytes for resource to set.
     * @return This builder for chaining.
     */
    public Builder setResourceBytes(org.apache.ratis.thirdparty.com.google.protobuf.ByteString value) {
      if (value == null) {
        throw new NullPointerException();
      }
      checkByteStringIsUtf8(value);

      resource_ = value;
      onChanged();
      return this;
    }

    private java.lang.Object permission_ = "";
    /**
     *
     *
     * <pre>
     * The required IAM permission.
     * </pre>
     *
     * <code>string permission = 2;</code>
     *
     * @return The permission.
     */
    public java.lang.String getPermission() {
      java.lang.Object ref = permission_;
      if (!(ref instanceof java.lang.String)) {
        org.apache.ratis.thirdparty.com.google.protobuf.ByteString bs = (org.apache.ratis.thirdparty.com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        permission_ = s;
        return s;
      } else {
        return (java.lang.String) ref;
      }
    }
    /**
     *
     *
     * <pre>
     * The required IAM permission.
     * </pre>
     *
     * <code>string permission = 2;</code>
     *
     * @return The bytes for permission.
     */
    public org.apache.ratis.thirdparty.com.google.protobuf.ByteString getPermissionBytes() {
      java.lang.Object ref = permission_;
      if (ref instanceof String) {
        org.apache.ratis.thirdparty.com.google.protobuf.ByteString b =
            org.apache.ratis.thirdparty.com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
        permission_ = b;
        return b;
      } else {
        return (org.apache.ratis.thirdparty.com.google.protobuf.ByteString) ref;
      }
    }
    /**
     *
     *
     * <pre>
     * The required IAM permission.
     * </pre>
     *
     * <code>string permission = 2;</code>
     *
     * @param value The permission to set.
     * @return This builder for chaining.
     */
    public Builder setPermission(java.lang.String value) {
      if (value == null) {
        throw new NullPointerException();
      }

      permission_ = value;
      onChanged();
      return this;
    }
    /**
     *
     *
     * <pre>
     * The required IAM permission.
     * </pre>
     *
     * <code>string permission = 2;</code>
     *
     * @return This builder for chaining.
     */
    public Builder clearPermission() {

      permission_ = getDefaultInstance().getPermission();
      onChanged();
      return this;
    }
    /**
     *
     *
     * <pre>
     * The required IAM permission.
     * </pre>
     *
     * <code>string permission = 2;</code>
     *
     * @param value The bytes for permission to set.
     * @return This builder for chaining.
     */
    public Builder setPermissionBytes(org.apache.ratis.thirdparty.com.google.protobuf.ByteString value) {
      if (value == null) {
        throw new NullPointerException();
      }
      checkByteStringIsUtf8(value);

      permission_ = value;
      onChanged();
      return this;
    }

    private boolean granted_;
    /**
     *
     *
     * <pre>
     * Whether or not authorization for `resource` and `permission`
     * was granted.
     * </pre>
     *
     * <code>bool granted = 3;</code>
     *
     * @return The granted.
     */
    @java.lang.Override
    public boolean getGranted() {
      return granted_;
    }
    /**
     *
     *
     * <pre>
     * Whether or not authorization for `resource` and `permission`
     * was granted.
     * </pre>
     *
     * <code>bool granted = 3;</code>
     *
     * @param value The granted to set.
     * @return This builder for chaining.
     */
    public Builder setGranted(boolean value) {

      granted_ = value;
      onChanged();
      return this;
    }
    /**
     *
     *
     * <pre>
     * Whether or not authorization for `resource` and `permission`
     * was granted.
     * </pre>
     *
     * <code>bool granted = 3;</code>
     *
     * @return This builder for chaining.
     */
    public Builder clearGranted() {

      granted_ = false;
      onChanged();
      return this;
    }

    private org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.Resource resourceAttributes_;
    private org.apache.ratis.thirdparty.com.google.protobuf.SingleFieldBuilderV3<
            org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.Resource,
            org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.Resource.Builder,
            org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.ResourceOrBuilder>
        resourceAttributesBuilder_;
    /**
     *
     *
     * <pre>
     * Resource attributes used in IAM condition evaluation. This field contains
     * resource attributes like resource type and resource name.
     * To get the whole view of the attributes used in IAM
     * condition evaluation, the user must also look into
     * `AuditLog.request_metadata.request_attributes`.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Resource resource_attributes = 5;</code>
     *
     * @return Whether the resourceAttributes field is set.
     */
    public boolean hasResourceAttributes() {
      return resourceAttributesBuilder_ != null || resourceAttributes_ != null;
    }
    /**
     *
     *
     * <pre>
     * Resource attributes used in IAM condition evaluation. This field contains
     * resource attributes like resource type and resource name.
     * To get the whole view of the attributes used in IAM
     * condition evaluation, the user must also look into
     * `AuditLog.request_metadata.request_attributes`.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Resource resource_attributes = 5;</code>
     *
     * @return The resourceAttributes.
     */
    public org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.Resource getResourceAttributes() {
      if (resourceAttributesBuilder_ == null) {
        return resourceAttributes_ == null
            ? org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.Resource.getDefaultInstance()
            : resourceAttributes_;
      } else {
        return resourceAttributesBuilder_.getMessage();
      }
    }
    /**
     *
     *
     * <pre>
     * Resource attributes used in IAM condition evaluation. This field contains
     * resource attributes like resource type and resource name.
     * To get the whole view of the attributes used in IAM
     * condition evaluation, the user must also look into
     * `AuditLog.request_metadata.request_attributes`.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Resource resource_attributes = 5;</code>
     */
    public Builder setResourceAttributes(org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.Resource value) {
      if (resourceAttributesBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        resourceAttributes_ = value;
        onChanged();
      } else {
        resourceAttributesBuilder_.setMessage(value);
      }

      return this;
    }
    /**
     *
     *
     * <pre>
     * Resource attributes used in IAM condition evaluation. This field contains
     * resource attributes like resource type and resource name.
     * To get the whole view of the attributes used in IAM
     * condition evaluation, the user must also look into
     * `AuditLog.request_metadata.request_attributes`.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Resource resource_attributes = 5;</code>
     */
    public Builder setResourceAttributes(
        org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.Resource.Builder builderForValue) {
      if (resourceAttributesBuilder_ == null) {
        resourceAttributes_ = builderForValue.build();
        onChanged();
      } else {
        resourceAttributesBuilder_.setMessage(builderForValue.build());
      }

      return this;
    }
    /**
     *
     *
     * <pre>
     * Resource attributes used in IAM condition evaluation. This field contains
     * resource attributes like resource type and resource name.
     * To get the whole view of the attributes used in IAM
     * condition evaluation, the user must also look into
     * `AuditLog.request_metadata.request_attributes`.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Resource resource_attributes = 5;</code>
     */
    public Builder mergeResourceAttributes(org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.Resource value) {
      if (resourceAttributesBuilder_ == null) {
        if (resourceAttributes_ != null) {
          resourceAttributes_ =
              org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.Resource.newBuilder(resourceAttributes_)
                  .mergeFrom(value)
                  .buildPartial();
        } else {
          resourceAttributes_ = value;
        }
        onChanged();
      } else {
        resourceAttributesBuilder_.mergeFrom(value);
      }

      return this;
    }
    /**
     *
     *
     * <pre>
     * Resource attributes used in IAM condition evaluation. This field contains
     * resource attributes like resource type and resource name.
     * To get the whole view of the attributes used in IAM
     * condition evaluation, the user must also look into
     * `AuditLog.request_metadata.request_attributes`.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Resource resource_attributes = 5;</code>
     */
    public Builder clearResourceAttributes() {
      if (resourceAttributesBuilder_ == null) {
        resourceAttributes_ = null;
        onChanged();
      } else {
        resourceAttributes_ = null;
        resourceAttributesBuilder_ = null;
      }

      return this;
    }
    /**
     *
     *
     * <pre>
     * Resource attributes used in IAM condition evaluation. This field contains
     * resource attributes like resource type and resource name.
     * To get the whole view of the attributes used in IAM
     * condition evaluation, the user must also look into
     * `AuditLog.request_metadata.request_attributes`.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Resource resource_attributes = 5;</code>
     */
    public org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.Resource.Builder getResourceAttributesBuilder() {

      onChanged();
      return getResourceAttributesFieldBuilder().getBuilder();
    }
    /**
     *
     *
     * <pre>
     * Resource attributes used in IAM condition evaluation. This field contains
     * resource attributes like resource type and resource name.
     * To get the whole view of the attributes used in IAM
     * condition evaluation, the user must also look into
     * `AuditLog.request_metadata.request_attributes`.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Resource resource_attributes = 5;</code>
     */
    public org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.ResourceOrBuilder
        getResourceAttributesOrBuilder() {
      if (resourceAttributesBuilder_ != null) {
        return resourceAttributesBuilder_.getMessageOrBuilder();
      } else {
        return resourceAttributes_ == null
            ? org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.Resource.getDefaultInstance()
            : resourceAttributes_;
      }
    }
    /**
     *
     *
     * <pre>
     * Resource attributes used in IAM condition evaluation. This field contains
     * resource attributes like resource type and resource name.
     * To get the whole view of the attributes used in IAM
     * condition evaluation, the user must also look into
     * `AuditLog.request_metadata.request_attributes`.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Resource resource_attributes = 5;</code>
     */
    private org.apache.ratis.thirdparty.com.google.protobuf.SingleFieldBuilderV3<
            org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.Resource,
            org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.Resource.Builder,
            org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.ResourceOrBuilder>
        getResourceAttributesFieldBuilder() {
      if (resourceAttributesBuilder_ == null) {
        resourceAttributesBuilder_ =
            new org.apache.ratis.thirdparty.com.google.protobuf.SingleFieldBuilderV3<
                org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.Resource,
                org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.Resource.Builder,
                org.apache.ratis.thirdparty.com.google.rpc.context.AttributeContext.ResourceOrBuilder>(
                getResourceAttributes(), getParentForChildren(), isClean());
        resourceAttributes_ = null;
      }
      return resourceAttributesBuilder_;
    }

    @java.lang.Override
    public final Builder setUnknownFields(final org.apache.ratis.thirdparty.com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final org.apache.ratis.thirdparty.com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }

    // @@protoc_insertion_point(builder_scope:google.cloud.audit.AuthorizationInfo)
  }

  // @@protoc_insertion_point(class_scope:google.cloud.audit.AuthorizationInfo)
  private static final org.apache.ratis.thirdparty.com.google.cloud.audit.AuthorizationInfo DEFAULT_INSTANCE;

  static {
    DEFAULT_INSTANCE = new org.apache.ratis.thirdparty.com.google.cloud.audit.AuthorizationInfo();
  }

  public static org.apache.ratis.thirdparty.com.google.cloud.audit.AuthorizationInfo getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final org.apache.ratis.thirdparty.com.google.protobuf.Parser<AuthorizationInfo> PARSER =
      new org.apache.ratis.thirdparty.com.google.protobuf.AbstractParser<AuthorizationInfo>() {
        @java.lang.Override
        public AuthorizationInfo parsePartialFrom(
            org.apache.ratis.thirdparty.com.google.protobuf.CodedInputStream input,
            org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
          return new AuthorizationInfo(input, extensionRegistry);
        }
      };

  public static org.apache.ratis.thirdparty.com.google.protobuf.Parser<AuthorizationInfo> parser() {
    return PARSER;
  }

  @java.lang.Override
  public org.apache.ratis.thirdparty.com.google.protobuf.Parser<AuthorizationInfo> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public org.apache.ratis.thirdparty.com.google.cloud.audit.AuthorizationInfo getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }
}
