/*
 * Copyright 2020 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: google/cloud/audit/audit_log.proto

package org.apache.ratis.thirdparty.com.google.cloud.audit;

/**
 *
 *
 * <pre>
 * Identity delegation history of an authenticated service account.
 * </pre>
 *
 * Protobuf type {@code google.cloud.audit.ServiceAccountDelegationInfo}
 */
public final class ServiceAccountDelegationInfo extends org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3
    implements
    // @@protoc_insertion_point(message_implements:google.cloud.audit.ServiceAccountDelegationInfo)
    ServiceAccountDelegationInfoOrBuilder {
  private static final long serialVersionUID = 0L;
  // Use ServiceAccountDelegationInfo.newBuilder() to construct.
  private ServiceAccountDelegationInfo(org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }

  private ServiceAccountDelegationInfo() {}

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(UnusedPrivateParameter unused) {
    return new ServiceAccountDelegationInfo();
  }

  @java.lang.Override
  public final org.apache.ratis.thirdparty.com.google.protobuf.UnknownFieldSet getUnknownFields() {
    return this.unknownFields;
  }

  private ServiceAccountDelegationInfo(
      org.apache.ratis.thirdparty.com.google.protobuf.CodedInputStream input,
      org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
    this();
    if (extensionRegistry == null) {
      throw new java.lang.NullPointerException();
    }
    org.apache.ratis.thirdparty.com.google.protobuf.UnknownFieldSet.Builder unknownFields =
        org.apache.ratis.thirdparty.com.google.protobuf.UnknownFieldSet.newBuilder();
    try {
      boolean done = false;
      while (!done) {
        int tag = input.readTag();
        switch (tag) {
          case 0:
            done = true;
            break;
          case 10:
            {
              org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal.Builder
                  subBuilder = null;
              if (authorityCase_ == 1) {
                subBuilder =
                    ((org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal)
                            authority_)
                        .toBuilder();
              }
              authority_ =
                  input.readMessage(
                      org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal
                          .parser(),
                      extensionRegistry);
              if (subBuilder != null) {
                subBuilder.mergeFrom(
                    (org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal)
                        authority_);
                authority_ = subBuilder.buildPartial();
              }
              authorityCase_ = 1;
              break;
            }
          case 18:
            {
              org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal.Builder
                  subBuilder = null;
              if (authorityCase_ == 2) {
                subBuilder =
                    ((org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal)
                            authority_)
                        .toBuilder();
              }
              authority_ =
                  input.readMessage(
                      org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal
                          .parser(),
                      extensionRegistry);
              if (subBuilder != null) {
                subBuilder.mergeFrom(
                    (org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal)
                        authority_);
                authority_ = subBuilder.buildPartial();
              }
              authorityCase_ = 2;
              break;
            }
          default:
            {
              if (!parseUnknownField(input, unknownFields, extensionRegistry, tag)) {
                done = true;
              }
              break;
            }
        }
      }
    } catch (org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException e) {
      throw e.setUnfinishedMessage(this);
    } catch (java.io.IOException e) {
      throw new org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException(e).setUnfinishedMessage(this);
    } finally {
      this.unknownFields = unknownFields.build();
      makeExtensionsImmutable();
    }
  }

  public static final org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.Descriptor getDescriptor() {
    return org.apache.ratis.thirdparty.com.google.cloud.audit.AuditLogProto
        .internal_static_google_cloud_audit_ServiceAccountDelegationInfo_descriptor;
  }

  @java.lang.Override
  protected org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return org.apache.ratis.thirdparty.com.google.cloud.audit.AuditLogProto
        .internal_static_google_cloud_audit_ServiceAccountDelegationInfo_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.class,
            org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.Builder.class);
  }

  public interface FirstPartyPrincipalOrBuilder
      extends
      // @@protoc_insertion_point(interface_extends:google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal)
      org.apache.ratis.thirdparty.com.google.protobuf.MessageOrBuilder {

    /**
     *
     *
     * <pre>
     * The email address of a Google account.
     * </pre>
     *
     * <code>string principal_email = 1;</code>
     *
     * @return The principalEmail.
     */
    java.lang.String getPrincipalEmail();
    /**
     *
     *
     * <pre>
     * The email address of a Google account.
     * </pre>
     *
     * <code>string principal_email = 1;</code>
     *
     * @return The bytes for principalEmail.
     */
    org.apache.ratis.thirdparty.com.google.protobuf.ByteString getPrincipalEmailBytes();

    /**
     *
     *
     * <pre>
     * Metadata about the service that uses the service account.
     * </pre>
     *
     * <code>.google.protobuf.Struct service_metadata = 2;</code>
     *
     * @return Whether the serviceMetadata field is set.
     */
    boolean hasServiceMetadata();
    /**
     *
     *
     * <pre>
     * Metadata about the service that uses the service account.
     * </pre>
     *
     * <code>.google.protobuf.Struct service_metadata = 2;</code>
     *
     * @return The serviceMetadata.
     */
    org.apache.ratis.thirdparty.com.google.protobuf.Struct getServiceMetadata();
    /**
     *
     *
     * <pre>
     * Metadata about the service that uses the service account.
     * </pre>
     *
     * <code>.google.protobuf.Struct service_metadata = 2;</code>
     */
    org.apache.ratis.thirdparty.com.google.protobuf.StructOrBuilder getServiceMetadataOrBuilder();
  }
  /**
   *
   *
   * <pre>
   * First party identity principal.
   * </pre>
   *
   * Protobuf type {@code google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal}
   */
  public static final class FirstPartyPrincipal extends org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3
      implements
      // @@protoc_insertion_point(message_implements:google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal)
      FirstPartyPrincipalOrBuilder {
    private static final long serialVersionUID = 0L;
    // Use FirstPartyPrincipal.newBuilder() to construct.
    private FirstPartyPrincipal(org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }

    private FirstPartyPrincipal() {
      principalEmail_ = "";
    }

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(UnusedPrivateParameter unused) {
      return new FirstPartyPrincipal();
    }

    @java.lang.Override
    public final org.apache.ratis.thirdparty.com.google.protobuf.UnknownFieldSet getUnknownFields() {
      return this.unknownFields;
    }

    private FirstPartyPrincipal(
        org.apache.ratis.thirdparty.com.google.protobuf.CodedInputStream input,
        org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
      this();
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      org.apache.ratis.thirdparty.com.google.protobuf.UnknownFieldSet.Builder unknownFields =
          org.apache.ratis.thirdparty.com.google.protobuf.UnknownFieldSet.newBuilder();
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10:
              {
                java.lang.String s = input.readStringRequireUtf8();

                principalEmail_ = s;
                break;
              }
            case 18:
              {
                org.apache.ratis.thirdparty.com.google.protobuf.Struct.Builder subBuilder = null;
                if (serviceMetadata_ != null) {
                  subBuilder = serviceMetadata_.toBuilder();
                }
                serviceMetadata_ =
                    input.readMessage(org.apache.ratis.thirdparty.com.google.protobuf.Struct.parser(), extensionRegistry);
                if (subBuilder != null) {
                  subBuilder.mergeFrom(serviceMetadata_);
                  serviceMetadata_ = subBuilder.buildPartial();
                }

                break;
              }
            default:
              {
                if (!parseUnknownField(input, unknownFields, extensionRegistry, tag)) {
                  done = true;
                }
                break;
              }
          }
        }
      } catch (org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(this);
      } catch (java.io.IOException e) {
        throw new org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException(e).setUnfinishedMessage(this);
      } finally {
        this.unknownFields = unknownFields.build();
        makeExtensionsImmutable();
      }
    }

    public static final org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.Descriptor getDescriptor() {
      return org.apache.ratis.thirdparty.com.google.cloud.audit.AuditLogProto
          .internal_static_google_cloud_audit_ServiceAccountDelegationInfo_FirstPartyPrincipal_descriptor;
    }

    @java.lang.Override
    protected org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return org.apache.ratis.thirdparty.com.google.cloud.audit.AuditLogProto
          .internal_static_google_cloud_audit_ServiceAccountDelegationInfo_FirstPartyPrincipal_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal.class,
              org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal.Builder
                  .class);
    }

    public static final int PRINCIPAL_EMAIL_FIELD_NUMBER = 1;
    private volatile java.lang.Object principalEmail_;
    /**
     *
     *
     * <pre>
     * The email address of a Google account.
     * </pre>
     *
     * <code>string principal_email = 1;</code>
     *
     * @return The principalEmail.
     */
    @java.lang.Override
    public java.lang.String getPrincipalEmail() {
      java.lang.Object ref = principalEmail_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        org.apache.ratis.thirdparty.com.google.protobuf.ByteString bs = (org.apache.ratis.thirdparty.com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        principalEmail_ = s;
        return s;
      }
    }
    /**
     *
     *
     * <pre>
     * The email address of a Google account.
     * </pre>
     *
     * <code>string principal_email = 1;</code>
     *
     * @return The bytes for principalEmail.
     */
    @java.lang.Override
    public org.apache.ratis.thirdparty.com.google.protobuf.ByteString getPrincipalEmailBytes() {
      java.lang.Object ref = principalEmail_;
      if (ref instanceof java.lang.String) {
        org.apache.ratis.thirdparty.com.google.protobuf.ByteString b =
            org.apache.ratis.thirdparty.com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
        principalEmail_ = b;
        return b;
      } else {
        return (org.apache.ratis.thirdparty.com.google.protobuf.ByteString) ref;
      }
    }

    public static final int SERVICE_METADATA_FIELD_NUMBER = 2;
    private org.apache.ratis.thirdparty.com.google.protobuf.Struct serviceMetadata_;
    /**
     *
     *
     * <pre>
     * Metadata about the service that uses the service account.
     * </pre>
     *
     * <code>.google.protobuf.Struct service_metadata = 2;</code>
     *
     * @return Whether the serviceMetadata field is set.
     */
    @java.lang.Override
    public boolean hasServiceMetadata() {
      return serviceMetadata_ != null;
    }
    /**
     *
     *
     * <pre>
     * Metadata about the service that uses the service account.
     * </pre>
     *
     * <code>.google.protobuf.Struct service_metadata = 2;</code>
     *
     * @return The serviceMetadata.
     */
    @java.lang.Override
    public org.apache.ratis.thirdparty.com.google.protobuf.Struct getServiceMetadata() {
      return serviceMetadata_ == null
          ? org.apache.ratis.thirdparty.com.google.protobuf.Struct.getDefaultInstance()
          : serviceMetadata_;
    }
    /**
     *
     *
     * <pre>
     * Metadata about the service that uses the service account.
     * </pre>
     *
     * <code>.google.protobuf.Struct service_metadata = 2;</code>
     */
    @java.lang.Override
    public org.apache.ratis.thirdparty.com.google.protobuf.StructOrBuilder getServiceMetadataOrBuilder() {
      return getServiceMetadata();
    }

    private byte memoizedIsInitialized = -1;

    @java.lang.Override
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      memoizedIsInitialized = 1;
      return true;
    }

    @java.lang.Override
    public void writeTo(org.apache.ratis.thirdparty.com.google.protobuf.CodedOutputStream output) throws java.io.IOException {
      if (!getPrincipalEmailBytes().isEmpty()) {
        org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.writeString(output, 1, principalEmail_);
      }
      if (serviceMetadata_ != null) {
        output.writeMessage(2, getServiceMetadata());
      }
      unknownFields.writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      if (!getPrincipalEmailBytes().isEmpty()) {
        size += org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.computeStringSize(1, principalEmail_);
      }
      if (serviceMetadata_ != null) {
        size += org.apache.ratis.thirdparty.com.google.protobuf.CodedOutputStream.computeMessageSize(2, getServiceMetadata());
      }
      size += unknownFields.getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
        return true;
      }
      if (!(obj
          instanceof org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal)) {
        return super.equals(obj);
      }
      org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal other =
          (org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal) obj;

      if (!getPrincipalEmail().equals(other.getPrincipalEmail())) return false;
      if (hasServiceMetadata() != other.hasServiceMetadata()) return false;
      if (hasServiceMetadata()) {
        if (!getServiceMetadata().equals(other.getServiceMetadata())) return false;
      }
      if (!unknownFields.equals(other.unknownFields)) return false;
      return true;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      hash = (37 * hash) + PRINCIPAL_EMAIL_FIELD_NUMBER;
      hash = (53 * hash) + getPrincipalEmail().hashCode();
      if (hasServiceMetadata()) {
        hash = (37 * hash) + SERVICE_METADATA_FIELD_NUMBER;
        hash = (53 * hash) + getServiceMetadata().hashCode();
      }
      hash = (29 * hash) + unknownFields.hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal parseFrom(
        java.nio.ByteBuffer data) throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }

    public static org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal parseFrom(
        java.nio.ByteBuffer data, org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }

    public static org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal parseFrom(
        org.apache.ratis.thirdparty.com.google.protobuf.ByteString data)
        throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }

    public static org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal parseFrom(
        org.apache.ratis.thirdparty.com.google.protobuf.ByteString data,
        org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }

    public static org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal parseFrom(
        byte[] data) throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }

    public static org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal parseFrom(
        byte[] data, org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }

    public static org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal parseFrom(
        java.io.InputStream input) throws java.io.IOException {
      return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseWithIOException(PARSER, input);
    }

    public static org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal parseFrom(
        java.io.InputStream input, org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseWithIOException(
          PARSER, input, extensionRegistry);
    }

    public static org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal
        parseDelimitedFrom(java.io.InputStream input) throws java.io.IOException {
      return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseDelimitedWithIOException(PARSER, input);
    }

    public static org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal
        parseDelimitedFrom(
            java.io.InputStream input, org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws java.io.IOException {
      return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseDelimitedWithIOException(
          PARSER, input, extensionRegistry);
    }

    public static org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal parseFrom(
        org.apache.ratis.thirdparty.com.google.protobuf.CodedInputStream input) throws java.io.IOException {
      return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseWithIOException(PARSER, input);
    }

    public static org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal parseFrom(
        org.apache.ratis.thirdparty.com.google.protobuf.CodedInputStream input,
        org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseWithIOException(
          PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() {
      return newBuilder();
    }

    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }

    public static Builder newBuilder(
        org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }

    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     *
     *
     * <pre>
     * First party identity principal.
     * </pre>
     *
     * Protobuf type {@code google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal}
     */
    public static final class Builder
        extends org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.Builder<Builder>
        implements
        // @@protoc_insertion_point(builder_implements:google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal)
        org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipalOrBuilder {
      public static final org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.Descriptor getDescriptor() {
        return org.apache.ratis.thirdparty.com.google.cloud.audit.AuditLogProto
            .internal_static_google_cloud_audit_ServiceAccountDelegationInfo_FirstPartyPrincipal_descriptor;
      }

      @java.lang.Override
      protected org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return org.apache.ratis.thirdparty.com.google.cloud.audit.AuditLogProto
            .internal_static_google_cloud_audit_ServiceAccountDelegationInfo_FirstPartyPrincipal_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal.class,
                org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal.Builder
                    .class);
      }

      // Construct using
      // org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }

      private Builder(org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }

      private void maybeForceBuilderInitialization() {
        if (org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.alwaysUseFieldBuilders) {}
      }

      @java.lang.Override
      public Builder clear() {
        super.clear();
        principalEmail_ = "";

        if (serviceMetadataBuilder_ == null) {
          serviceMetadata_ = null;
        } else {
          serviceMetadata_ = null;
          serviceMetadataBuilder_ = null;
        }
        return this;
      }

      @java.lang.Override
      public org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.Descriptor getDescriptorForType() {
        return org.apache.ratis.thirdparty.com.google.cloud.audit.AuditLogProto
            .internal_static_google_cloud_audit_ServiceAccountDelegationInfo_FirstPartyPrincipal_descriptor;
      }

      @java.lang.Override
      public org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal
          getDefaultInstanceForType() {
        return org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal
            .getDefaultInstance();
      }

      @java.lang.Override
      public org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal build() {
        org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal result =
            buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal
          buildPartial() {
        org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal result =
            new org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal(this);
        result.principalEmail_ = principalEmail_;
        if (serviceMetadataBuilder_ == null) {
          result.serviceMetadata_ = serviceMetadata_;
        } else {
          result.serviceMetadata_ = serviceMetadataBuilder_.build();
        }
        onBuilt();
        return result;
      }

      @java.lang.Override
      public Builder clone() {
        return super.clone();
      }

      @java.lang.Override
      public Builder setField(
          org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.FieldDescriptor field, java.lang.Object value) {
        return super.setField(field, value);
      }

      @java.lang.Override
      public Builder clearField(org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.FieldDescriptor field) {
        return super.clearField(field);
      }

      @java.lang.Override
      public Builder clearOneof(org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.OneofDescriptor oneof) {
        return super.clearOneof(oneof);
      }

      @java.lang.Override
      public Builder setRepeatedField(
          org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.FieldDescriptor field,
          int index,
          java.lang.Object value) {
        return super.setRepeatedField(field, index, value);
      }

      @java.lang.Override
      public Builder addRepeatedField(
          org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.FieldDescriptor field, java.lang.Object value) {
        return super.addRepeatedField(field, value);
      }

      @java.lang.Override
      public Builder mergeFrom(org.apache.ratis.thirdparty.com.google.protobuf.Message other) {
        if (other
            instanceof org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal) {
          return mergeFrom(
              (org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal) other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(
          org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal other) {
        if (other
            == org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal
                .getDefaultInstance()) return this;
        if (!other.getPrincipalEmail().isEmpty()) {
          principalEmail_ = other.principalEmail_;
          onChanged();
        }
        if (other.hasServiceMetadata()) {
          mergeServiceMetadata(other.getServiceMetadata());
        }
        this.mergeUnknownFields(other.unknownFields);
        onChanged();
        return this;
      }

      @java.lang.Override
      public final boolean isInitialized() {
        return true;
      }

      @java.lang.Override
      public Builder mergeFrom(
          org.apache.ratis.thirdparty.com.google.protobuf.CodedInputStream input,
          org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal parsedMessage =
            null;
        try {
          parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
        } catch (org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException e) {
          parsedMessage =
              (org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal)
                  e.getUnfinishedMessage();
          throw e.unwrapIOException();
        } finally {
          if (parsedMessage != null) {
            mergeFrom(parsedMessage);
          }
        }
        return this;
      }

      private java.lang.Object principalEmail_ = "";
      /**
       *
       *
       * <pre>
       * The email address of a Google account.
       * </pre>
       *
       * <code>string principal_email = 1;</code>
       *
       * @return The principalEmail.
       */
      public java.lang.String getPrincipalEmail() {
        java.lang.Object ref = principalEmail_;
        if (!(ref instanceof java.lang.String)) {
          org.apache.ratis.thirdparty.com.google.protobuf.ByteString bs = (org.apache.ratis.thirdparty.com.google.protobuf.ByteString) ref;
          java.lang.String s = bs.toStringUtf8();
          principalEmail_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       *
       *
       * <pre>
       * The email address of a Google account.
       * </pre>
       *
       * <code>string principal_email = 1;</code>
       *
       * @return The bytes for principalEmail.
       */
      public org.apache.ratis.thirdparty.com.google.protobuf.ByteString getPrincipalEmailBytes() {
        java.lang.Object ref = principalEmail_;
        if (ref instanceof String) {
          org.apache.ratis.thirdparty.com.google.protobuf.ByteString b =
              org.apache.ratis.thirdparty.com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
          principalEmail_ = b;
          return b;
        } else {
          return (org.apache.ratis.thirdparty.com.google.protobuf.ByteString) ref;
        }
      }
      /**
       *
       *
       * <pre>
       * The email address of a Google account.
       * </pre>
       *
       * <code>string principal_email = 1;</code>
       *
       * @param value The principalEmail to set.
       * @return This builder for chaining.
       */
      public Builder setPrincipalEmail(java.lang.String value) {
        if (value == null) {
          throw new NullPointerException();
        }

        principalEmail_ = value;
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The email address of a Google account.
       * </pre>
       *
       * <code>string principal_email = 1;</code>
       *
       * @return This builder for chaining.
       */
      public Builder clearPrincipalEmail() {

        principalEmail_ = getDefaultInstance().getPrincipalEmail();
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The email address of a Google account.
       * </pre>
       *
       * <code>string principal_email = 1;</code>
       *
       * @param value The bytes for principalEmail to set.
       * @return This builder for chaining.
       */
      public Builder setPrincipalEmailBytes(org.apache.ratis.thirdparty.com.google.protobuf.ByteString value) {
        if (value == null) {
          throw new NullPointerException();
        }
        checkByteStringIsUtf8(value);

        principalEmail_ = value;
        onChanged();
        return this;
      }

      private org.apache.ratis.thirdparty.com.google.protobuf.Struct serviceMetadata_;
      private org.apache.ratis.thirdparty.com.google.protobuf.SingleFieldBuilderV3<
              org.apache.ratis.thirdparty.com.google.protobuf.Struct,
              org.apache.ratis.thirdparty.com.google.protobuf.Struct.Builder,
              org.apache.ratis.thirdparty.com.google.protobuf.StructOrBuilder>
          serviceMetadataBuilder_;
      /**
       *
       *
       * <pre>
       * Metadata about the service that uses the service account.
       * </pre>
       *
       * <code>.google.protobuf.Struct service_metadata = 2;</code>
       *
       * @return Whether the serviceMetadata field is set.
       */
      public boolean hasServiceMetadata() {
        return serviceMetadataBuilder_ != null || serviceMetadata_ != null;
      }
      /**
       *
       *
       * <pre>
       * Metadata about the service that uses the service account.
       * </pre>
       *
       * <code>.google.protobuf.Struct service_metadata = 2;</code>
       *
       * @return The serviceMetadata.
       */
      public org.apache.ratis.thirdparty.com.google.protobuf.Struct getServiceMetadata() {
        if (serviceMetadataBuilder_ == null) {
          return serviceMetadata_ == null
              ? org.apache.ratis.thirdparty.com.google.protobuf.Struct.getDefaultInstance()
              : serviceMetadata_;
        } else {
          return serviceMetadataBuilder_.getMessage();
        }
      }
      /**
       *
       *
       * <pre>
       * Metadata about the service that uses the service account.
       * </pre>
       *
       * <code>.google.protobuf.Struct service_metadata = 2;</code>
       */
      public Builder setServiceMetadata(org.apache.ratis.thirdparty.com.google.protobuf.Struct value) {
        if (serviceMetadataBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          serviceMetadata_ = value;
          onChanged();
        } else {
          serviceMetadataBuilder_.setMessage(value);
        }

        return this;
      }
      /**
       *
       *
       * <pre>
       * Metadata about the service that uses the service account.
       * </pre>
       *
       * <code>.google.protobuf.Struct service_metadata = 2;</code>
       */
      public Builder setServiceMetadata(org.apache.ratis.thirdparty.com.google.protobuf.Struct.Builder builderForValue) {
        if (serviceMetadataBuilder_ == null) {
          serviceMetadata_ = builderForValue.build();
          onChanged();
        } else {
          serviceMetadataBuilder_.setMessage(builderForValue.build());
        }

        return this;
      }
      /**
       *
       *
       * <pre>
       * Metadata about the service that uses the service account.
       * </pre>
       *
       * <code>.google.protobuf.Struct service_metadata = 2;</code>
       */
      public Builder mergeServiceMetadata(org.apache.ratis.thirdparty.com.google.protobuf.Struct value) {
        if (serviceMetadataBuilder_ == null) {
          if (serviceMetadata_ != null) {
            serviceMetadata_ =
                org.apache.ratis.thirdparty.com.google.protobuf.Struct.newBuilder(serviceMetadata_)
                    .mergeFrom(value)
                    .buildPartial();
          } else {
            serviceMetadata_ = value;
          }
          onChanged();
        } else {
          serviceMetadataBuilder_.mergeFrom(value);
        }

        return this;
      }
      /**
       *
       *
       * <pre>
       * Metadata about the service that uses the service account.
       * </pre>
       *
       * <code>.google.protobuf.Struct service_metadata = 2;</code>
       */
      public Builder clearServiceMetadata() {
        if (serviceMetadataBuilder_ == null) {
          serviceMetadata_ = null;
          onChanged();
        } else {
          serviceMetadata_ = null;
          serviceMetadataBuilder_ = null;
        }

        return this;
      }
      /**
       *
       *
       * <pre>
       * Metadata about the service that uses the service account.
       * </pre>
       *
       * <code>.google.protobuf.Struct service_metadata = 2;</code>
       */
      public org.apache.ratis.thirdparty.com.google.protobuf.Struct.Builder getServiceMetadataBuilder() {

        onChanged();
        return getServiceMetadataFieldBuilder().getBuilder();
      }
      /**
       *
       *
       * <pre>
       * Metadata about the service that uses the service account.
       * </pre>
       *
       * <code>.google.protobuf.Struct service_metadata = 2;</code>
       */
      public org.apache.ratis.thirdparty.com.google.protobuf.StructOrBuilder getServiceMetadataOrBuilder() {
        if (serviceMetadataBuilder_ != null) {
          return serviceMetadataBuilder_.getMessageOrBuilder();
        } else {
          return serviceMetadata_ == null
              ? org.apache.ratis.thirdparty.com.google.protobuf.Struct.getDefaultInstance()
              : serviceMetadata_;
        }
      }
      /**
       *
       *
       * <pre>
       * Metadata about the service that uses the service account.
       * </pre>
       *
       * <code>.google.protobuf.Struct service_metadata = 2;</code>
       */
      private org.apache.ratis.thirdparty.com.google.protobuf.SingleFieldBuilderV3<
              org.apache.ratis.thirdparty.com.google.protobuf.Struct,
              org.apache.ratis.thirdparty.com.google.protobuf.Struct.Builder,
              org.apache.ratis.thirdparty.com.google.protobuf.StructOrBuilder>
          getServiceMetadataFieldBuilder() {
        if (serviceMetadataBuilder_ == null) {
          serviceMetadataBuilder_ =
              new org.apache.ratis.thirdparty.com.google.protobuf.SingleFieldBuilderV3<
                  org.apache.ratis.thirdparty.com.google.protobuf.Struct,
                  org.apache.ratis.thirdparty.com.google.protobuf.Struct.Builder,
                  org.apache.ratis.thirdparty.com.google.protobuf.StructOrBuilder>(
                  getServiceMetadata(), getParentForChildren(), isClean());
          serviceMetadata_ = null;
        }
        return serviceMetadataBuilder_;
      }

      @java.lang.Override
      public final Builder setUnknownFields(
          final org.apache.ratis.thirdparty.com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.setUnknownFields(unknownFields);
      }

      @java.lang.Override
      public final Builder mergeUnknownFields(
          final org.apache.ratis.thirdparty.com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }

      // @@protoc_insertion_point(builder_scope:google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal)
    }

    // @@protoc_insertion_point(class_scope:google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal)
    private static final org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal
        DEFAULT_INSTANCE;

    static {
      DEFAULT_INSTANCE =
          new org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal();
    }

    public static org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal
        getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    private static final org.apache.ratis.thirdparty.com.google.protobuf.Parser<FirstPartyPrincipal> PARSER =
        new org.apache.ratis.thirdparty.com.google.protobuf.AbstractParser<FirstPartyPrincipal>() {
          @java.lang.Override
          public FirstPartyPrincipal parsePartialFrom(
              org.apache.ratis.thirdparty.com.google.protobuf.CodedInputStream input,
              org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
              throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
            return new FirstPartyPrincipal(input, extensionRegistry);
          }
        };

    public static org.apache.ratis.thirdparty.com.google.protobuf.Parser<FirstPartyPrincipal> parser() {
      return PARSER;
    }

    @java.lang.Override
    public org.apache.ratis.thirdparty.com.google.protobuf.Parser<FirstPartyPrincipal> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal
        getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }
  }

  public interface ThirdPartyPrincipalOrBuilder
      extends
      // @@protoc_insertion_point(interface_extends:google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal)
      org.apache.ratis.thirdparty.com.google.protobuf.MessageOrBuilder {

    /**
     *
     *
     * <pre>
     * Metadata about third party identity.
     * </pre>
     *
     * <code>.google.protobuf.Struct third_party_claims = 1;</code>
     *
     * @return Whether the thirdPartyClaims field is set.
     */
    boolean hasThirdPartyClaims();
    /**
     *
     *
     * <pre>
     * Metadata about third party identity.
     * </pre>
     *
     * <code>.google.protobuf.Struct third_party_claims = 1;</code>
     *
     * @return The thirdPartyClaims.
     */
    org.apache.ratis.thirdparty.com.google.protobuf.Struct getThirdPartyClaims();
    /**
     *
     *
     * <pre>
     * Metadata about third party identity.
     * </pre>
     *
     * <code>.google.protobuf.Struct third_party_claims = 1;</code>
     */
    org.apache.ratis.thirdparty.com.google.protobuf.StructOrBuilder getThirdPartyClaimsOrBuilder();
  }
  /**
   *
   *
   * <pre>
   * Third party identity principal.
   * </pre>
   *
   * Protobuf type {@code google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal}
   */
  public static final class ThirdPartyPrincipal extends org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3
      implements
      // @@protoc_insertion_point(message_implements:google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal)
      ThirdPartyPrincipalOrBuilder {
    private static final long serialVersionUID = 0L;
    // Use ThirdPartyPrincipal.newBuilder() to construct.
    private ThirdPartyPrincipal(org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }

    private ThirdPartyPrincipal() {}

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(UnusedPrivateParameter unused) {
      return new ThirdPartyPrincipal();
    }

    @java.lang.Override
    public final org.apache.ratis.thirdparty.com.google.protobuf.UnknownFieldSet getUnknownFields() {
      return this.unknownFields;
    }

    private ThirdPartyPrincipal(
        org.apache.ratis.thirdparty.com.google.protobuf.CodedInputStream input,
        org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
      this();
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      org.apache.ratis.thirdparty.com.google.protobuf.UnknownFieldSet.Builder unknownFields =
          org.apache.ratis.thirdparty.com.google.protobuf.UnknownFieldSet.newBuilder();
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10:
              {
                org.apache.ratis.thirdparty.com.google.protobuf.Struct.Builder subBuilder = null;
                if (thirdPartyClaims_ != null) {
                  subBuilder = thirdPartyClaims_.toBuilder();
                }
                thirdPartyClaims_ =
                    input.readMessage(org.apache.ratis.thirdparty.com.google.protobuf.Struct.parser(), extensionRegistry);
                if (subBuilder != null) {
                  subBuilder.mergeFrom(thirdPartyClaims_);
                  thirdPartyClaims_ = subBuilder.buildPartial();
                }

                break;
              }
            default:
              {
                if (!parseUnknownField(input, unknownFields, extensionRegistry, tag)) {
                  done = true;
                }
                break;
              }
          }
        }
      } catch (org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(this);
      } catch (java.io.IOException e) {
        throw new org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException(e).setUnfinishedMessage(this);
      } finally {
        this.unknownFields = unknownFields.build();
        makeExtensionsImmutable();
      }
    }

    public static final org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.Descriptor getDescriptor() {
      return org.apache.ratis.thirdparty.com.google.cloud.audit.AuditLogProto
          .internal_static_google_cloud_audit_ServiceAccountDelegationInfo_ThirdPartyPrincipal_descriptor;
    }

    @java.lang.Override
    protected org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return org.apache.ratis.thirdparty.com.google.cloud.audit.AuditLogProto
          .internal_static_google_cloud_audit_ServiceAccountDelegationInfo_ThirdPartyPrincipal_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal.class,
              org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal.Builder
                  .class);
    }

    public static final int THIRD_PARTY_CLAIMS_FIELD_NUMBER = 1;
    private org.apache.ratis.thirdparty.com.google.protobuf.Struct thirdPartyClaims_;
    /**
     *
     *
     * <pre>
     * Metadata about third party identity.
     * </pre>
     *
     * <code>.google.protobuf.Struct third_party_claims = 1;</code>
     *
     * @return Whether the thirdPartyClaims field is set.
     */
    @java.lang.Override
    public boolean hasThirdPartyClaims() {
      return thirdPartyClaims_ != null;
    }
    /**
     *
     *
     * <pre>
     * Metadata about third party identity.
     * </pre>
     *
     * <code>.google.protobuf.Struct third_party_claims = 1;</code>
     *
     * @return The thirdPartyClaims.
     */
    @java.lang.Override
    public org.apache.ratis.thirdparty.com.google.protobuf.Struct getThirdPartyClaims() {
      return thirdPartyClaims_ == null
          ? org.apache.ratis.thirdparty.com.google.protobuf.Struct.getDefaultInstance()
          : thirdPartyClaims_;
    }
    /**
     *
     *
     * <pre>
     * Metadata about third party identity.
     * </pre>
     *
     * <code>.google.protobuf.Struct third_party_claims = 1;</code>
     */
    @java.lang.Override
    public org.apache.ratis.thirdparty.com.google.protobuf.StructOrBuilder getThirdPartyClaimsOrBuilder() {
      return getThirdPartyClaims();
    }

    private byte memoizedIsInitialized = -1;

    @java.lang.Override
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      memoizedIsInitialized = 1;
      return true;
    }

    @java.lang.Override
    public void writeTo(org.apache.ratis.thirdparty.com.google.protobuf.CodedOutputStream output) throws java.io.IOException {
      if (thirdPartyClaims_ != null) {
        output.writeMessage(1, getThirdPartyClaims());
      }
      unknownFields.writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      if (thirdPartyClaims_ != null) {
        size += org.apache.ratis.thirdparty.com.google.protobuf.CodedOutputStream.computeMessageSize(1, getThirdPartyClaims());
      }
      size += unknownFields.getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
        return true;
      }
      if (!(obj
          instanceof org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal)) {
        return super.equals(obj);
      }
      org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal other =
          (org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal) obj;

      if (hasThirdPartyClaims() != other.hasThirdPartyClaims()) return false;
      if (hasThirdPartyClaims()) {
        if (!getThirdPartyClaims().equals(other.getThirdPartyClaims())) return false;
      }
      if (!unknownFields.equals(other.unknownFields)) return false;
      return true;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      if (hasThirdPartyClaims()) {
        hash = (37 * hash) + THIRD_PARTY_CLAIMS_FIELD_NUMBER;
        hash = (53 * hash) + getThirdPartyClaims().hashCode();
      }
      hash = (29 * hash) + unknownFields.hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal parseFrom(
        java.nio.ByteBuffer data) throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }

    public static org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal parseFrom(
        java.nio.ByteBuffer data, org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }

    public static org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal parseFrom(
        org.apache.ratis.thirdparty.com.google.protobuf.ByteString data)
        throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }

    public static org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal parseFrom(
        org.apache.ratis.thirdparty.com.google.protobuf.ByteString data,
        org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }

    public static org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal parseFrom(
        byte[] data) throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }

    public static org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal parseFrom(
        byte[] data, org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }

    public static org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal parseFrom(
        java.io.InputStream input) throws java.io.IOException {
      return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseWithIOException(PARSER, input);
    }

    public static org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal parseFrom(
        java.io.InputStream input, org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseWithIOException(
          PARSER, input, extensionRegistry);
    }

    public static org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal
        parseDelimitedFrom(java.io.InputStream input) throws java.io.IOException {
      return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseDelimitedWithIOException(PARSER, input);
    }

    public static org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal
        parseDelimitedFrom(
            java.io.InputStream input, org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws java.io.IOException {
      return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseDelimitedWithIOException(
          PARSER, input, extensionRegistry);
    }

    public static org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal parseFrom(
        org.apache.ratis.thirdparty.com.google.protobuf.CodedInputStream input) throws java.io.IOException {
      return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseWithIOException(PARSER, input);
    }

    public static org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal parseFrom(
        org.apache.ratis.thirdparty.com.google.protobuf.CodedInputStream input,
        org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseWithIOException(
          PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() {
      return newBuilder();
    }

    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }

    public static Builder newBuilder(
        org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }

    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     *
     *
     * <pre>
     * Third party identity principal.
     * </pre>
     *
     * Protobuf type {@code google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal}
     */
    public static final class Builder
        extends org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.Builder<Builder>
        implements
        // @@protoc_insertion_point(builder_implements:google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal)
        org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipalOrBuilder {
      public static final org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.Descriptor getDescriptor() {
        return org.apache.ratis.thirdparty.com.google.cloud.audit.AuditLogProto
            .internal_static_google_cloud_audit_ServiceAccountDelegationInfo_ThirdPartyPrincipal_descriptor;
      }

      @java.lang.Override
      protected org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return org.apache.ratis.thirdparty.com.google.cloud.audit.AuditLogProto
            .internal_static_google_cloud_audit_ServiceAccountDelegationInfo_ThirdPartyPrincipal_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal.class,
                org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal.Builder
                    .class);
      }

      // Construct using
      // org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }

      private Builder(org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }

      private void maybeForceBuilderInitialization() {
        if (org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.alwaysUseFieldBuilders) {}
      }

      @java.lang.Override
      public Builder clear() {
        super.clear();
        if (thirdPartyClaimsBuilder_ == null) {
          thirdPartyClaims_ = null;
        } else {
          thirdPartyClaims_ = null;
          thirdPartyClaimsBuilder_ = null;
        }
        return this;
      }

      @java.lang.Override
      public org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.Descriptor getDescriptorForType() {
        return org.apache.ratis.thirdparty.com.google.cloud.audit.AuditLogProto
            .internal_static_google_cloud_audit_ServiceAccountDelegationInfo_ThirdPartyPrincipal_descriptor;
      }

      @java.lang.Override
      public org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal
          getDefaultInstanceForType() {
        return org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal
            .getDefaultInstance();
      }

      @java.lang.Override
      public org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal build() {
        org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal result =
            buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal
          buildPartial() {
        org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal result =
            new org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal(this);
        if (thirdPartyClaimsBuilder_ == null) {
          result.thirdPartyClaims_ = thirdPartyClaims_;
        } else {
          result.thirdPartyClaims_ = thirdPartyClaimsBuilder_.build();
        }
        onBuilt();
        return result;
      }

      @java.lang.Override
      public Builder clone() {
        return super.clone();
      }

      @java.lang.Override
      public Builder setField(
          org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.FieldDescriptor field, java.lang.Object value) {
        return super.setField(field, value);
      }

      @java.lang.Override
      public Builder clearField(org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.FieldDescriptor field) {
        return super.clearField(field);
      }

      @java.lang.Override
      public Builder clearOneof(org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.OneofDescriptor oneof) {
        return super.clearOneof(oneof);
      }

      @java.lang.Override
      public Builder setRepeatedField(
          org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.FieldDescriptor field,
          int index,
          java.lang.Object value) {
        return super.setRepeatedField(field, index, value);
      }

      @java.lang.Override
      public Builder addRepeatedField(
          org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.FieldDescriptor field, java.lang.Object value) {
        return super.addRepeatedField(field, value);
      }

      @java.lang.Override
      public Builder mergeFrom(org.apache.ratis.thirdparty.com.google.protobuf.Message other) {
        if (other
            instanceof org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal) {
          return mergeFrom(
              (org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal) other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(
          org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal other) {
        if (other
            == org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal
                .getDefaultInstance()) return this;
        if (other.hasThirdPartyClaims()) {
          mergeThirdPartyClaims(other.getThirdPartyClaims());
        }
        this.mergeUnknownFields(other.unknownFields);
        onChanged();
        return this;
      }

      @java.lang.Override
      public final boolean isInitialized() {
        return true;
      }

      @java.lang.Override
      public Builder mergeFrom(
          org.apache.ratis.thirdparty.com.google.protobuf.CodedInputStream input,
          org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal parsedMessage =
            null;
        try {
          parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
        } catch (org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException e) {
          parsedMessage =
              (org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal)
                  e.getUnfinishedMessage();
          throw e.unwrapIOException();
        } finally {
          if (parsedMessage != null) {
            mergeFrom(parsedMessage);
          }
        }
        return this;
      }

      private org.apache.ratis.thirdparty.com.google.protobuf.Struct thirdPartyClaims_;
      private org.apache.ratis.thirdparty.com.google.protobuf.SingleFieldBuilderV3<
              org.apache.ratis.thirdparty.com.google.protobuf.Struct,
              org.apache.ratis.thirdparty.com.google.protobuf.Struct.Builder,
              org.apache.ratis.thirdparty.com.google.protobuf.StructOrBuilder>
          thirdPartyClaimsBuilder_;
      /**
       *
       *
       * <pre>
       * Metadata about third party identity.
       * </pre>
       *
       * <code>.google.protobuf.Struct third_party_claims = 1;</code>
       *
       * @return Whether the thirdPartyClaims field is set.
       */
      public boolean hasThirdPartyClaims() {
        return thirdPartyClaimsBuilder_ != null || thirdPartyClaims_ != null;
      }
      /**
       *
       *
       * <pre>
       * Metadata about third party identity.
       * </pre>
       *
       * <code>.google.protobuf.Struct third_party_claims = 1;</code>
       *
       * @return The thirdPartyClaims.
       */
      public org.apache.ratis.thirdparty.com.google.protobuf.Struct getThirdPartyClaims() {
        if (thirdPartyClaimsBuilder_ == null) {
          return thirdPartyClaims_ == null
              ? org.apache.ratis.thirdparty.com.google.protobuf.Struct.getDefaultInstance()
              : thirdPartyClaims_;
        } else {
          return thirdPartyClaimsBuilder_.getMessage();
        }
      }
      /**
       *
       *
       * <pre>
       * Metadata about third party identity.
       * </pre>
       *
       * <code>.google.protobuf.Struct third_party_claims = 1;</code>
       */
      public Builder setThirdPartyClaims(org.apache.ratis.thirdparty.com.google.protobuf.Struct value) {
        if (thirdPartyClaimsBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          thirdPartyClaims_ = value;
          onChanged();
        } else {
          thirdPartyClaimsBuilder_.setMessage(value);
        }

        return this;
      }
      /**
       *
       *
       * <pre>
       * Metadata about third party identity.
       * </pre>
       *
       * <code>.google.protobuf.Struct third_party_claims = 1;</code>
       */
      public Builder setThirdPartyClaims(org.apache.ratis.thirdparty.com.google.protobuf.Struct.Builder builderForValue) {
        if (thirdPartyClaimsBuilder_ == null) {
          thirdPartyClaims_ = builderForValue.build();
          onChanged();
        } else {
          thirdPartyClaimsBuilder_.setMessage(builderForValue.build());
        }

        return this;
      }
      /**
       *
       *
       * <pre>
       * Metadata about third party identity.
       * </pre>
       *
       * <code>.google.protobuf.Struct third_party_claims = 1;</code>
       */
      public Builder mergeThirdPartyClaims(org.apache.ratis.thirdparty.com.google.protobuf.Struct value) {
        if (thirdPartyClaimsBuilder_ == null) {
          if (thirdPartyClaims_ != null) {
            thirdPartyClaims_ =
                org.apache.ratis.thirdparty.com.google.protobuf.Struct.newBuilder(thirdPartyClaims_)
                    .mergeFrom(value)
                    .buildPartial();
          } else {
            thirdPartyClaims_ = value;
          }
          onChanged();
        } else {
          thirdPartyClaimsBuilder_.mergeFrom(value);
        }

        return this;
      }
      /**
       *
       *
       * <pre>
       * Metadata about third party identity.
       * </pre>
       *
       * <code>.google.protobuf.Struct third_party_claims = 1;</code>
       */
      public Builder clearThirdPartyClaims() {
        if (thirdPartyClaimsBuilder_ == null) {
          thirdPartyClaims_ = null;
          onChanged();
        } else {
          thirdPartyClaims_ = null;
          thirdPartyClaimsBuilder_ = null;
        }

        return this;
      }
      /**
       *
       *
       * <pre>
       * Metadata about third party identity.
       * </pre>
       *
       * <code>.google.protobuf.Struct third_party_claims = 1;</code>
       */
      public org.apache.ratis.thirdparty.com.google.protobuf.Struct.Builder getThirdPartyClaimsBuilder() {

        onChanged();
        return getThirdPartyClaimsFieldBuilder().getBuilder();
      }
      /**
       *
       *
       * <pre>
       * Metadata about third party identity.
       * </pre>
       *
       * <code>.google.protobuf.Struct third_party_claims = 1;</code>
       */
      public org.apache.ratis.thirdparty.com.google.protobuf.StructOrBuilder getThirdPartyClaimsOrBuilder() {
        if (thirdPartyClaimsBuilder_ != null) {
          return thirdPartyClaimsBuilder_.getMessageOrBuilder();
        } else {
          return thirdPartyClaims_ == null
              ? org.apache.ratis.thirdparty.com.google.protobuf.Struct.getDefaultInstance()
              : thirdPartyClaims_;
        }
      }
      /**
       *
       *
       * <pre>
       * Metadata about third party identity.
       * </pre>
       *
       * <code>.google.protobuf.Struct third_party_claims = 1;</code>
       */
      private org.apache.ratis.thirdparty.com.google.protobuf.SingleFieldBuilderV3<
              org.apache.ratis.thirdparty.com.google.protobuf.Struct,
              org.apache.ratis.thirdparty.com.google.protobuf.Struct.Builder,
              org.apache.ratis.thirdparty.com.google.protobuf.StructOrBuilder>
          getThirdPartyClaimsFieldBuilder() {
        if (thirdPartyClaimsBuilder_ == null) {
          thirdPartyClaimsBuilder_ =
              new org.apache.ratis.thirdparty.com.google.protobuf.SingleFieldBuilderV3<
                  org.apache.ratis.thirdparty.com.google.protobuf.Struct,
                  org.apache.ratis.thirdparty.com.google.protobuf.Struct.Builder,
                  org.apache.ratis.thirdparty.com.google.protobuf.StructOrBuilder>(
                  getThirdPartyClaims(), getParentForChildren(), isClean());
          thirdPartyClaims_ = null;
        }
        return thirdPartyClaimsBuilder_;
      }

      @java.lang.Override
      public final Builder setUnknownFields(
          final org.apache.ratis.thirdparty.com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.setUnknownFields(unknownFields);
      }

      @java.lang.Override
      public final Builder mergeUnknownFields(
          final org.apache.ratis.thirdparty.com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }

      // @@protoc_insertion_point(builder_scope:google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal)
    }

    // @@protoc_insertion_point(class_scope:google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal)
    private static final org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal
        DEFAULT_INSTANCE;

    static {
      DEFAULT_INSTANCE =
          new org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal();
    }

    public static org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal
        getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    private static final org.apache.ratis.thirdparty.com.google.protobuf.Parser<ThirdPartyPrincipal> PARSER =
        new org.apache.ratis.thirdparty.com.google.protobuf.AbstractParser<ThirdPartyPrincipal>() {
          @java.lang.Override
          public ThirdPartyPrincipal parsePartialFrom(
              org.apache.ratis.thirdparty.com.google.protobuf.CodedInputStream input,
              org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
              throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
            return new ThirdPartyPrincipal(input, extensionRegistry);
          }
        };

    public static org.apache.ratis.thirdparty.com.google.protobuf.Parser<ThirdPartyPrincipal> parser() {
      return PARSER;
    }

    @java.lang.Override
    public org.apache.ratis.thirdparty.com.google.protobuf.Parser<ThirdPartyPrincipal> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal
        getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }
  }

  private int authorityCase_ = 0;
  private java.lang.Object authority_;

  public enum AuthorityCase
      implements
          org.apache.ratis.thirdparty.com.google.protobuf.Internal.EnumLite,
          org.apache.ratis.thirdparty.com.google.protobuf.AbstractMessage.InternalOneOfEnum {
    FIRST_PARTY_PRINCIPAL(1),
    THIRD_PARTY_PRINCIPAL(2),
    AUTHORITY_NOT_SET(0);
    private final int value;

    private AuthorityCase(int value) {
      this.value = value;
    }
    /**
     * @param value The number of the enum to look for.
     * @return The enum associated with the given number.
     * @deprecated Use {@link #forNumber(int)} instead.
     */
    @java.lang.Deprecated
    public static AuthorityCase valueOf(int value) {
      return forNumber(value);
    }

    public static AuthorityCase forNumber(int value) {
      switch (value) {
        case 1:
          return FIRST_PARTY_PRINCIPAL;
        case 2:
          return THIRD_PARTY_PRINCIPAL;
        case 0:
          return AUTHORITY_NOT_SET;
        default:
          return null;
      }
    }

    public int getNumber() {
      return this.value;
    }
  };

  public AuthorityCase getAuthorityCase() {
    return AuthorityCase.forNumber(authorityCase_);
  }

  public static final int FIRST_PARTY_PRINCIPAL_FIELD_NUMBER = 1;
  /**
   *
   *
   * <pre>
   * First party (Google) identity as the real authority.
   * </pre>
   *
   * <code>
   * .google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal first_party_principal = 1;
   * </code>
   *
   * @return Whether the firstPartyPrincipal field is set.
   */
  @java.lang.Override
  public boolean hasFirstPartyPrincipal() {
    return authorityCase_ == 1;
  }
  /**
   *
   *
   * <pre>
   * First party (Google) identity as the real authority.
   * </pre>
   *
   * <code>
   * .google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal first_party_principal = 1;
   * </code>
   *
   * @return The firstPartyPrincipal.
   */
  @java.lang.Override
  public org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal
      getFirstPartyPrincipal() {
    if (authorityCase_ == 1) {
      return (org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal) authority_;
    }
    return org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal
        .getDefaultInstance();
  }
  /**
   *
   *
   * <pre>
   * First party (Google) identity as the real authority.
   * </pre>
   *
   * <code>
   * .google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal first_party_principal = 1;
   * </code>
   */
  @java.lang.Override
  public org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipalOrBuilder
      getFirstPartyPrincipalOrBuilder() {
    if (authorityCase_ == 1) {
      return (org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal) authority_;
    }
    return org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal
        .getDefaultInstance();
  }

  public static final int THIRD_PARTY_PRINCIPAL_FIELD_NUMBER = 2;
  /**
   *
   *
   * <pre>
   * Third party identity as the real authority.
   * </pre>
   *
   * <code>
   * .google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal third_party_principal = 2;
   * </code>
   *
   * @return Whether the thirdPartyPrincipal field is set.
   */
  @java.lang.Override
  public boolean hasThirdPartyPrincipal() {
    return authorityCase_ == 2;
  }
  /**
   *
   *
   * <pre>
   * Third party identity as the real authority.
   * </pre>
   *
   * <code>
   * .google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal third_party_principal = 2;
   * </code>
   *
   * @return The thirdPartyPrincipal.
   */
  @java.lang.Override
  public org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal
      getThirdPartyPrincipal() {
    if (authorityCase_ == 2) {
      return (org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal) authority_;
    }
    return org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal
        .getDefaultInstance();
  }
  /**
   *
   *
   * <pre>
   * Third party identity as the real authority.
   * </pre>
   *
   * <code>
   * .google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal third_party_principal = 2;
   * </code>
   */
  @java.lang.Override
  public org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipalOrBuilder
      getThirdPartyPrincipalOrBuilder() {
    if (authorityCase_ == 2) {
      return (org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal) authority_;
    }
    return org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal
        .getDefaultInstance();
  }

  private byte memoizedIsInitialized = -1;

  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(org.apache.ratis.thirdparty.com.google.protobuf.CodedOutputStream output) throws java.io.IOException {
    if (authorityCase_ == 1) {
      output.writeMessage(
          1, (org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal) authority_);
    }
    if (authorityCase_ == 2) {
      output.writeMessage(
          2, (org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal) authority_);
    }
    unknownFields.writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (authorityCase_ == 1) {
      size +=
          org.apache.ratis.thirdparty.com.google.protobuf.CodedOutputStream.computeMessageSize(
              1,
              (org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal) authority_);
    }
    if (authorityCase_ == 2) {
      size +=
          org.apache.ratis.thirdparty.com.google.protobuf.CodedOutputStream.computeMessageSize(
              2,
              (org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal) authority_);
    }
    size += unknownFields.getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
      return true;
    }
    if (!(obj instanceof org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo)) {
      return super.equals(obj);
    }
    org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo other =
        (org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo) obj;

    if (!getAuthorityCase().equals(other.getAuthorityCase())) return false;
    switch (authorityCase_) {
      case 1:
        if (!getFirstPartyPrincipal().equals(other.getFirstPartyPrincipal())) return false;
        break;
      case 2:
        if (!getThirdPartyPrincipal().equals(other.getThirdPartyPrincipal())) return false;
        break;
      case 0:
      default:
    }
    if (!unknownFields.equals(other.unknownFields)) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    switch (authorityCase_) {
      case 1:
        hash = (37 * hash) + FIRST_PARTY_PRINCIPAL_FIELD_NUMBER;
        hash = (53 * hash) + getFirstPartyPrincipal().hashCode();
        break;
      case 2:
        hash = (37 * hash) + THIRD_PARTY_PRINCIPAL_FIELD_NUMBER;
        hash = (53 * hash) + getThirdPartyPrincipal().hashCode();
        break;
      case 0:
      default:
    }
    hash = (29 * hash) + unknownFields.hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo parseFrom(
      java.nio.ByteBuffer data) throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }

  public static org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo parseFrom(
      java.nio.ByteBuffer data, org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }

  public static org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo parseFrom(
      org.apache.ratis.thirdparty.com.google.protobuf.ByteString data)
      throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }

  public static org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo parseFrom(
      org.apache.ratis.thirdparty.com.google.protobuf.ByteString data,
      org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }

  public static org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo parseFrom(byte[] data)
      throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }

  public static org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo parseFrom(
      byte[] data, org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }

  public static org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo parseFrom(
      java.io.InputStream input) throws java.io.IOException {
    return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseWithIOException(PARSER, input);
  }

  public static org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo parseFrom(
      java.io.InputStream input, org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseWithIOException(
        PARSER, input, extensionRegistry);
  }

  public static org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo parseDelimitedFrom(
      java.io.InputStream input) throws java.io.IOException {
    return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseDelimitedWithIOException(PARSER, input);
  }

  public static org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo parseDelimitedFrom(
      java.io.InputStream input, org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseDelimitedWithIOException(
        PARSER, input, extensionRegistry);
  }

  public static org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo parseFrom(
      org.apache.ratis.thirdparty.com.google.protobuf.CodedInputStream input) throws java.io.IOException {
    return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseWithIOException(PARSER, input);
  }

  public static org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo parseFrom(
      org.apache.ratis.thirdparty.com.google.protobuf.CodedInputStream input,
      org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.parseWithIOException(
        PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() {
    return newBuilder();
  }

  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }

  public static Builder newBuilder(org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }

  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   *
   *
   * <pre>
   * Identity delegation history of an authenticated service account.
   * </pre>
   *
   * Protobuf type {@code google.cloud.audit.ServiceAccountDelegationInfo}
   */
  public static final class Builder extends org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.Builder<Builder>
      implements
      // @@protoc_insertion_point(builder_implements:google.cloud.audit.ServiceAccountDelegationInfo)
      org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfoOrBuilder {
    public static final org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.Descriptor getDescriptor() {
      return org.apache.ratis.thirdparty.com.google.cloud.audit.AuditLogProto
          .internal_static_google_cloud_audit_ServiceAccountDelegationInfo_descriptor;
    }

    @java.lang.Override
    protected org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return org.apache.ratis.thirdparty.com.google.cloud.audit.AuditLogProto
          .internal_static_google_cloud_audit_ServiceAccountDelegationInfo_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.class,
              org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.Builder.class);
    }

    // Construct using org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.newBuilder()
    private Builder() {
      maybeForceBuilderInitialization();
    }

    private Builder(org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);
      maybeForceBuilderInitialization();
    }

    private void maybeForceBuilderInitialization() {
      if (org.apache.ratis.thirdparty.com.google.protobuf.GeneratedMessageV3.alwaysUseFieldBuilders) {}
    }

    @java.lang.Override
    public Builder clear() {
      super.clear();
      authorityCase_ = 0;
      authority_ = null;
      return this;
    }

    @java.lang.Override
    public org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.Descriptor getDescriptorForType() {
      return org.apache.ratis.thirdparty.com.google.cloud.audit.AuditLogProto
          .internal_static_google_cloud_audit_ServiceAccountDelegationInfo_descriptor;
    }

    @java.lang.Override
    public org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo getDefaultInstanceForType() {
      return org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.getDefaultInstance();
    }

    @java.lang.Override
    public org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo build() {
      org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo buildPartial() {
      org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo result =
          new org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo(this);
      if (authorityCase_ == 1) {
        if (firstPartyPrincipalBuilder_ == null) {
          result.authority_ = authority_;
        } else {
          result.authority_ = firstPartyPrincipalBuilder_.build();
        }
      }
      if (authorityCase_ == 2) {
        if (thirdPartyPrincipalBuilder_ == null) {
          result.authority_ = authority_;
        } else {
          result.authority_ = thirdPartyPrincipalBuilder_.build();
        }
      }
      result.authorityCase_ = authorityCase_;
      onBuilt();
      return result;
    }

    @java.lang.Override
    public Builder clone() {
      return super.clone();
    }

    @java.lang.Override
    public Builder setField(
        org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.FieldDescriptor field, java.lang.Object value) {
      return super.setField(field, value);
    }

    @java.lang.Override
    public Builder clearField(org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.FieldDescriptor field) {
      return super.clearField(field);
    }

    @java.lang.Override
    public Builder clearOneof(org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.OneofDescriptor oneof) {
      return super.clearOneof(oneof);
    }

    @java.lang.Override
    public Builder setRepeatedField(
        org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.FieldDescriptor field, int index, java.lang.Object value) {
      return super.setRepeatedField(field, index, value);
    }

    @java.lang.Override
    public Builder addRepeatedField(
        org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.FieldDescriptor field, java.lang.Object value) {
      return super.addRepeatedField(field, value);
    }

    @java.lang.Override
    public Builder mergeFrom(org.apache.ratis.thirdparty.com.google.protobuf.Message other) {
      if (other instanceof org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo) {
        return mergeFrom((org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo) other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo other) {
      if (other == org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.getDefaultInstance())
        return this;
      switch (other.getAuthorityCase()) {
        case FIRST_PARTY_PRINCIPAL:
          {
            mergeFirstPartyPrincipal(other.getFirstPartyPrincipal());
            break;
          }
        case THIRD_PARTY_PRINCIPAL:
          {
            mergeThirdPartyPrincipal(other.getThirdPartyPrincipal());
            break;
          }
        case AUTHORITY_NOT_SET:
          {
            break;
          }
      }
      this.mergeUnknownFields(other.unknownFields);
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        org.apache.ratis.thirdparty.com.google.protobuf.CodedInputStream input,
        org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo parsedMessage = null;
      try {
        parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
      } catch (org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException e) {
        parsedMessage =
            (org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo) e.getUnfinishedMessage();
        throw e.unwrapIOException();
      } finally {
        if (parsedMessage != null) {
          mergeFrom(parsedMessage);
        }
      }
      return this;
    }

    private int authorityCase_ = 0;
    private java.lang.Object authority_;

    public AuthorityCase getAuthorityCase() {
      return AuthorityCase.forNumber(authorityCase_);
    }

    public Builder clearAuthority() {
      authorityCase_ = 0;
      authority_ = null;
      onChanged();
      return this;
    }

    private org.apache.ratis.thirdparty.com.google.protobuf.SingleFieldBuilderV3<
            org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal,
            org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal.Builder,
            org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipalOrBuilder>
        firstPartyPrincipalBuilder_;
    /**
     *
     *
     * <pre>
     * First party (Google) identity as the real authority.
     * </pre>
     *
     * <code>
     * .google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal first_party_principal = 1;
     * </code>
     *
     * @return Whether the firstPartyPrincipal field is set.
     */
    @java.lang.Override
    public boolean hasFirstPartyPrincipal() {
      return authorityCase_ == 1;
    }
    /**
     *
     *
     * <pre>
     * First party (Google) identity as the real authority.
     * </pre>
     *
     * <code>
     * .google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal first_party_principal = 1;
     * </code>
     *
     * @return The firstPartyPrincipal.
     */
    @java.lang.Override
    public org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal
        getFirstPartyPrincipal() {
      if (firstPartyPrincipalBuilder_ == null) {
        if (authorityCase_ == 1) {
          return (org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal)
              authority_;
        }
        return org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal
            .getDefaultInstance();
      } else {
        if (authorityCase_ == 1) {
          return firstPartyPrincipalBuilder_.getMessage();
        }
        return org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal
            .getDefaultInstance();
      }
    }
    /**
     *
     *
     * <pre>
     * First party (Google) identity as the real authority.
     * </pre>
     *
     * <code>
     * .google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal first_party_principal = 1;
     * </code>
     */
    public Builder setFirstPartyPrincipal(
        org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal value) {
      if (firstPartyPrincipalBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        authority_ = value;
        onChanged();
      } else {
        firstPartyPrincipalBuilder_.setMessage(value);
      }
      authorityCase_ = 1;
      return this;
    }
    /**
     *
     *
     * <pre>
     * First party (Google) identity as the real authority.
     * </pre>
     *
     * <code>
     * .google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal first_party_principal = 1;
     * </code>
     */
    public Builder setFirstPartyPrincipal(
        org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal.Builder
            builderForValue) {
      if (firstPartyPrincipalBuilder_ == null) {
        authority_ = builderForValue.build();
        onChanged();
      } else {
        firstPartyPrincipalBuilder_.setMessage(builderForValue.build());
      }
      authorityCase_ = 1;
      return this;
    }
    /**
     *
     *
     * <pre>
     * First party (Google) identity as the real authority.
     * </pre>
     *
     * <code>
     * .google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal first_party_principal = 1;
     * </code>
     */
    public Builder mergeFirstPartyPrincipal(
        org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal value) {
      if (firstPartyPrincipalBuilder_ == null) {
        if (authorityCase_ == 1
            && authority_
                != org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal
                    .getDefaultInstance()) {
          authority_ =
              org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal.newBuilder(
                      (org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal)
                          authority_)
                  .mergeFrom(value)
                  .buildPartial();
        } else {
          authority_ = value;
        }
        onChanged();
      } else {
        if (authorityCase_ == 1) {
          firstPartyPrincipalBuilder_.mergeFrom(value);
        }
        firstPartyPrincipalBuilder_.setMessage(value);
      }
      authorityCase_ = 1;
      return this;
    }
    /**
     *
     *
     * <pre>
     * First party (Google) identity as the real authority.
     * </pre>
     *
     * <code>
     * .google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal first_party_principal = 1;
     * </code>
     */
    public Builder clearFirstPartyPrincipal() {
      if (firstPartyPrincipalBuilder_ == null) {
        if (authorityCase_ == 1) {
          authorityCase_ = 0;
          authority_ = null;
          onChanged();
        }
      } else {
        if (authorityCase_ == 1) {
          authorityCase_ = 0;
          authority_ = null;
        }
        firstPartyPrincipalBuilder_.clear();
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * First party (Google) identity as the real authority.
     * </pre>
     *
     * <code>
     * .google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal first_party_principal = 1;
     * </code>
     */
    public org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal.Builder
        getFirstPartyPrincipalBuilder() {
      return getFirstPartyPrincipalFieldBuilder().getBuilder();
    }
    /**
     *
     *
     * <pre>
     * First party (Google) identity as the real authority.
     * </pre>
     *
     * <code>
     * .google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal first_party_principal = 1;
     * </code>
     */
    @java.lang.Override
    public org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipalOrBuilder
        getFirstPartyPrincipalOrBuilder() {
      if ((authorityCase_ == 1) && (firstPartyPrincipalBuilder_ != null)) {
        return firstPartyPrincipalBuilder_.getMessageOrBuilder();
      } else {
        if (authorityCase_ == 1) {
          return (org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal)
              authority_;
        }
        return org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal
            .getDefaultInstance();
      }
    }
    /**
     *
     *
     * <pre>
     * First party (Google) identity as the real authority.
     * </pre>
     *
     * <code>
     * .google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal first_party_principal = 1;
     * </code>
     */
    private org.apache.ratis.thirdparty.com.google.protobuf.SingleFieldBuilderV3<
            org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal,
            org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal.Builder,
            org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipalOrBuilder>
        getFirstPartyPrincipalFieldBuilder() {
      if (firstPartyPrincipalBuilder_ == null) {
        if (!(authorityCase_ == 1)) {
          authority_ =
              org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal
                  .getDefaultInstance();
        }
        firstPartyPrincipalBuilder_ =
            new org.apache.ratis.thirdparty.com.google.protobuf.SingleFieldBuilderV3<
                org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal,
                org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal.Builder,
                org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipalOrBuilder>(
                (org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.FirstPartyPrincipal)
                    authority_,
                getParentForChildren(),
                isClean());
        authority_ = null;
      }
      authorityCase_ = 1;
      onChanged();
      ;
      return firstPartyPrincipalBuilder_;
    }

    private org.apache.ratis.thirdparty.com.google.protobuf.SingleFieldBuilderV3<
            org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal,
            org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal.Builder,
            org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipalOrBuilder>
        thirdPartyPrincipalBuilder_;
    /**
     *
     *
     * <pre>
     * Third party identity as the real authority.
     * </pre>
     *
     * <code>
     * .google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal third_party_principal = 2;
     * </code>
     *
     * @return Whether the thirdPartyPrincipal field is set.
     */
    @java.lang.Override
    public boolean hasThirdPartyPrincipal() {
      return authorityCase_ == 2;
    }
    /**
     *
     *
     * <pre>
     * Third party identity as the real authority.
     * </pre>
     *
     * <code>
     * .google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal third_party_principal = 2;
     * </code>
     *
     * @return The thirdPartyPrincipal.
     */
    @java.lang.Override
    public org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal
        getThirdPartyPrincipal() {
      if (thirdPartyPrincipalBuilder_ == null) {
        if (authorityCase_ == 2) {
          return (org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal)
              authority_;
        }
        return org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal
            .getDefaultInstance();
      } else {
        if (authorityCase_ == 2) {
          return thirdPartyPrincipalBuilder_.getMessage();
        }
        return org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal
            .getDefaultInstance();
      }
    }
    /**
     *
     *
     * <pre>
     * Third party identity as the real authority.
     * </pre>
     *
     * <code>
     * .google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal third_party_principal = 2;
     * </code>
     */
    public Builder setThirdPartyPrincipal(
        org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal value) {
      if (thirdPartyPrincipalBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        authority_ = value;
        onChanged();
      } else {
        thirdPartyPrincipalBuilder_.setMessage(value);
      }
      authorityCase_ = 2;
      return this;
    }
    /**
     *
     *
     * <pre>
     * Third party identity as the real authority.
     * </pre>
     *
     * <code>
     * .google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal third_party_principal = 2;
     * </code>
     */
    public Builder setThirdPartyPrincipal(
        org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal.Builder
            builderForValue) {
      if (thirdPartyPrincipalBuilder_ == null) {
        authority_ = builderForValue.build();
        onChanged();
      } else {
        thirdPartyPrincipalBuilder_.setMessage(builderForValue.build());
      }
      authorityCase_ = 2;
      return this;
    }
    /**
     *
     *
     * <pre>
     * Third party identity as the real authority.
     * </pre>
     *
     * <code>
     * .google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal third_party_principal = 2;
     * </code>
     */
    public Builder mergeThirdPartyPrincipal(
        org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal value) {
      if (thirdPartyPrincipalBuilder_ == null) {
        if (authorityCase_ == 2
            && authority_
                != org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal
                    .getDefaultInstance()) {
          authority_ =
              org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal.newBuilder(
                      (org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal)
                          authority_)
                  .mergeFrom(value)
                  .buildPartial();
        } else {
          authority_ = value;
        }
        onChanged();
      } else {
        if (authorityCase_ == 2) {
          thirdPartyPrincipalBuilder_.mergeFrom(value);
        }
        thirdPartyPrincipalBuilder_.setMessage(value);
      }
      authorityCase_ = 2;
      return this;
    }
    /**
     *
     *
     * <pre>
     * Third party identity as the real authority.
     * </pre>
     *
     * <code>
     * .google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal third_party_principal = 2;
     * </code>
     */
    public Builder clearThirdPartyPrincipal() {
      if (thirdPartyPrincipalBuilder_ == null) {
        if (authorityCase_ == 2) {
          authorityCase_ = 0;
          authority_ = null;
          onChanged();
        }
      } else {
        if (authorityCase_ == 2) {
          authorityCase_ = 0;
          authority_ = null;
        }
        thirdPartyPrincipalBuilder_.clear();
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * Third party identity as the real authority.
     * </pre>
     *
     * <code>
     * .google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal third_party_principal = 2;
     * </code>
     */
    public org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal.Builder
        getThirdPartyPrincipalBuilder() {
      return getThirdPartyPrincipalFieldBuilder().getBuilder();
    }
    /**
     *
     *
     * <pre>
     * Third party identity as the real authority.
     * </pre>
     *
     * <code>
     * .google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal third_party_principal = 2;
     * </code>
     */
    @java.lang.Override
    public org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipalOrBuilder
        getThirdPartyPrincipalOrBuilder() {
      if ((authorityCase_ == 2) && (thirdPartyPrincipalBuilder_ != null)) {
        return thirdPartyPrincipalBuilder_.getMessageOrBuilder();
      } else {
        if (authorityCase_ == 2) {
          return (org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal)
              authority_;
        }
        return org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal
            .getDefaultInstance();
      }
    }
    /**
     *
     *
     * <pre>
     * Third party identity as the real authority.
     * </pre>
     *
     * <code>
     * .google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal third_party_principal = 2;
     * </code>
     */
    private org.apache.ratis.thirdparty.com.google.protobuf.SingleFieldBuilderV3<
            org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal,
            org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal.Builder,
            org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipalOrBuilder>
        getThirdPartyPrincipalFieldBuilder() {
      if (thirdPartyPrincipalBuilder_ == null) {
        if (!(authorityCase_ == 2)) {
          authority_ =
              org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal
                  .getDefaultInstance();
        }
        thirdPartyPrincipalBuilder_ =
            new org.apache.ratis.thirdparty.com.google.protobuf.SingleFieldBuilderV3<
                org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal,
                org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal.Builder,
                org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipalOrBuilder>(
                (org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo.ThirdPartyPrincipal)
                    authority_,
                getParentForChildren(),
                isClean());
        authority_ = null;
      }
      authorityCase_ = 2;
      onChanged();
      ;
      return thirdPartyPrincipalBuilder_;
    }

    @java.lang.Override
    public final Builder setUnknownFields(final org.apache.ratis.thirdparty.com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final org.apache.ratis.thirdparty.com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }

    // @@protoc_insertion_point(builder_scope:google.cloud.audit.ServiceAccountDelegationInfo)
  }

  // @@protoc_insertion_point(class_scope:google.cloud.audit.ServiceAccountDelegationInfo)
  private static final org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo DEFAULT_INSTANCE;

  static {
    DEFAULT_INSTANCE = new org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo();
  }

  public static org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final org.apache.ratis.thirdparty.com.google.protobuf.Parser<ServiceAccountDelegationInfo> PARSER =
      new org.apache.ratis.thirdparty.com.google.protobuf.AbstractParser<ServiceAccountDelegationInfo>() {
        @java.lang.Override
        public ServiceAccountDelegationInfo parsePartialFrom(
            org.apache.ratis.thirdparty.com.google.protobuf.CodedInputStream input,
            org.apache.ratis.thirdparty.com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws org.apache.ratis.thirdparty.com.google.protobuf.InvalidProtocolBufferException {
          return new ServiceAccountDelegationInfo(input, extensionRegistry);
        }
      };

  public static org.apache.ratis.thirdparty.com.google.protobuf.Parser<ServiceAccountDelegationInfo> parser() {
    return PARSER;
  }

  @java.lang.Override
  public org.apache.ratis.thirdparty.com.google.protobuf.Parser<ServiceAccountDelegationInfo> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public org.apache.ratis.thirdparty.com.google.cloud.audit.ServiceAccountDelegationInfo getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }
}
