/*
 * Copyright 2020 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: google/type/dayofweek.proto

package org.apache.ratis.thirdparty.com.google.type;

/**
 *
 *
 * <pre>
 * Represents a day of week.
 * </pre>
 *
 * Protobuf enum {@code google.type.DayOfWeek}
 */
public enum DayOfWeek implements org.apache.ratis.thirdparty.com.google.protobuf.ProtocolMessageEnum {
  /**
   *
   *
   * <pre>
   * The unspecified day-of-week.
   * </pre>
   *
   * <code>DAY_OF_WEEK_UNSPECIFIED = 0;</code>
   */
  DAY_OF_WEEK_UNSPECIFIED(0),
  /**
   *
   *
   * <pre>
   * The day-of-week of Monday.
   * </pre>
   *
   * <code>MONDAY = 1;</code>
   */
  MONDAY(1),
  /**
   *
   *
   * <pre>
   * The day-of-week of Tuesday.
   * </pre>
   *
   * <code>TUESDAY = 2;</code>
   */
  TUESDAY(2),
  /**
   *
   *
   * <pre>
   * The day-of-week of Wednesday.
   * </pre>
   *
   * <code>WEDNESDAY = 3;</code>
   */
  WEDNESDAY(3),
  /**
   *
   *
   * <pre>
   * The day-of-week of Thursday.
   * </pre>
   *
   * <code>THURSDAY = 4;</code>
   */
  THURSDAY(4),
  /**
   *
   *
   * <pre>
   * The day-of-week of Friday.
   * </pre>
   *
   * <code>FRIDAY = 5;</code>
   */
  FRIDAY(5),
  /**
   *
   *
   * <pre>
   * The day-of-week of Saturday.
   * </pre>
   *
   * <code>SATURDAY = 6;</code>
   */
  SATURDAY(6),
  /**
   *
   *
   * <pre>
   * The day-of-week of Sunday.
   * </pre>
   *
   * <code>SUNDAY = 7;</code>
   */
  SUNDAY(7),
  UNRECOGNIZED(-1),
  ;

  /**
   *
   *
   * <pre>
   * The unspecified day-of-week.
   * </pre>
   *
   * <code>DAY_OF_WEEK_UNSPECIFIED = 0;</code>
   */
  public static final int DAY_OF_WEEK_UNSPECIFIED_VALUE = 0;
  /**
   *
   *
   * <pre>
   * The day-of-week of Monday.
   * </pre>
   *
   * <code>MONDAY = 1;</code>
   */
  public static final int MONDAY_VALUE = 1;
  /**
   *
   *
   * <pre>
   * The day-of-week of Tuesday.
   * </pre>
   *
   * <code>TUESDAY = 2;</code>
   */
  public static final int TUESDAY_VALUE = 2;
  /**
   *
   *
   * <pre>
   * The day-of-week of Wednesday.
   * </pre>
   *
   * <code>WEDNESDAY = 3;</code>
   */
  public static final int WEDNESDAY_VALUE = 3;
  /**
   *
   *
   * <pre>
   * The day-of-week of Thursday.
   * </pre>
   *
   * <code>THURSDAY = 4;</code>
   */
  public static final int THURSDAY_VALUE = 4;
  /**
   *
   *
   * <pre>
   * The day-of-week of Friday.
   * </pre>
   *
   * <code>FRIDAY = 5;</code>
   */
  public static final int FRIDAY_VALUE = 5;
  /**
   *
   *
   * <pre>
   * The day-of-week of Saturday.
   * </pre>
   *
   * <code>SATURDAY = 6;</code>
   */
  public static final int SATURDAY_VALUE = 6;
  /**
   *
   *
   * <pre>
   * The day-of-week of Sunday.
   * </pre>
   *
   * <code>SUNDAY = 7;</code>
   */
  public static final int SUNDAY_VALUE = 7;

  public final int getNumber() {
    if (this == UNRECOGNIZED) {
      throw new java.lang.IllegalArgumentException(
          "Can't get the number of an unknown enum value.");
    }
    return value;
  }

  /**
   * @param value The numeric wire value of the corresponding enum entry.
   * @return The enum associated with the given numeric wire value.
   * @deprecated Use {@link #forNumber(int)} instead.
   */
  @java.lang.Deprecated
  public static DayOfWeek valueOf(int value) {
    return forNumber(value);
  }

  /**
   * @param value The numeric wire value of the corresponding enum entry.
   * @return The enum associated with the given numeric wire value.
   */
  public static DayOfWeek forNumber(int value) {
    switch (value) {
      case 0:
        return DAY_OF_WEEK_UNSPECIFIED;
      case 1:
        return MONDAY;
      case 2:
        return TUESDAY;
      case 3:
        return WEDNESDAY;
      case 4:
        return THURSDAY;
      case 5:
        return FRIDAY;
      case 6:
        return SATURDAY;
      case 7:
        return SUNDAY;
      default:
        return null;
    }
  }

  public static org.apache.ratis.thirdparty.com.google.protobuf.Internal.EnumLiteMap<DayOfWeek> internalGetValueMap() {
    return internalValueMap;
  }

  private static final org.apache.ratis.thirdparty.com.google.protobuf.Internal.EnumLiteMap<DayOfWeek> internalValueMap =
      new org.apache.ratis.thirdparty.com.google.protobuf.Internal.EnumLiteMap<DayOfWeek>() {
        public DayOfWeek findValueByNumber(int number) {
          return DayOfWeek.forNumber(number);
        }
      };

  public final org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.EnumValueDescriptor getValueDescriptor() {
    if (this == UNRECOGNIZED) {
      throw new java.lang.IllegalStateException(
          "Can't get the descriptor of an unrecognized enum value.");
    }
    return getDescriptor().getValues().get(ordinal());
  }

  public final org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.EnumDescriptor getDescriptorForType() {
    return getDescriptor();
  }

  public static final org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.EnumDescriptor getDescriptor() {
    return org.apache.ratis.thirdparty.com.google.type.DayOfWeekProto.getDescriptor().getEnumTypes().get(0);
  }

  private static final DayOfWeek[] VALUES = values();

  public static DayOfWeek valueOf(org.apache.ratis.thirdparty.com.google.protobuf.Descriptors.EnumValueDescriptor desc) {
    if (desc.getType() != getDescriptor()) {
      throw new java.lang.IllegalArgumentException("EnumValueDescriptor is not for this type.");
    }
    if (desc.getIndex() == -1) {
      return UNRECOGNIZED;
    }
    return VALUES[desc.getIndex()];
  }

  private final int value;

  private DayOfWeek(int value) {
    this.value = value;
  }

  // @@protoc_insertion_point(enum_scope:google.type.DayOfWeek)
}
